//
//  BlueToothManager+SendData.m
//  HandheldBluetooth
//
//  Created by 伟 on 2018/10/24.
//  Copyright © 2018年 ZW. All rights reserved.
//

#import "BlueToothManager+SendData.h"
#import "HexHelper.h"

@implementation BlueToothManager (SendData)

/**
 校检并转化成二进制

 @param strData  example @"7e 10 00 00"
 */
- (NSData *)sendString:(NSString *)strData {
    //    NSString *strData = @"7e 10 00 00";
    NSArray<NSString *> *dataArr = [strData componentsSeparatedByString:@" "];
    uint8_t bytes[dataArr.count];
    for (NSInteger i = 0; i< dataArr.count; i++) {
        NSString *obj = dataArr[i];
        UInt8 byte = (UInt8)strtol([obj UTF8String],0,16);
        bytes[i] = byte;
    }
    uint8_t result = crc8(bytes, dataArr.count);
    NSString * lastStr = [HexHelper ToHex:result];

    NSMutableString * mString = [NSMutableString string];
    for (NSString * str in dataArr) {
        [mString appendString:str];
    }
    [mString appendString:lastStr];
    NSData * data = [self hexToBytes:mString];
    //    NSLog(@"result:%@", data);
    return data;
}

- (NSData *)hexToBytes:(NSString *)str {
    NSMutableData* data = [NSMutableData data];
    int idx;
    for (idx = 0; idx+2 <= str.length; idx+=2) {
        NSRange range = NSMakeRange(idx, 2);
        NSString* hexStr = [str substringWithRange:range];
        NSScanner* scanner = [NSScanner scannerWithString:hexStr];
        unsigned int intValue;
        [scanner scanHexInt:&intValue];
        [data appendBytes:&intValue length:1];
    }
    return data;
}

uint8_t crc8(uint8_t *ptr, uint8_t len) {
    uint8_t i;
    uint8_t crc=0x00;
    while( len-- ) {
        crc ^= *ptr++;
        for( i = 8; i > 0; --i ) {
            if (crc & 0x80)
                crc = (crc << 1) ^ 0x31;
            else
                crc = (crc << 1);
        }
    }
    return (crc);
}

// 16进制转NSData
- (NSData *)convertHexStrToData:(NSString *)str
{
    if (!str || [str length] == 0) {
        return nil;
    }

    NSMutableData *hexData = [[NSMutableData alloc] initWithCapacity:20];
    NSRange range;
    if ([str length] % 2 == 0) {
        range = NSMakeRange(0, 2);
    } else {
        range = NSMakeRange(0, 1);
    }
    for (NSInteger i = range.location; i < [str length]; i += 2) {
        unsigned int anInt;
        NSString *hexCharStr = [str substringWithRange:range];
        NSScanner *scanner = [[NSScanner alloc] initWithString:hexCharStr];

        [scanner scanHexInt:&anInt];
        NSData *entity = [[NSData alloc] initWithBytes:&anInt length:1];
        [hexData appendData:entity];

        range.location += range.length;
        range.length = 2;
    }
    NSLog(@"hexData = %@",hexData);
    return hexData;

//    NSMutableData *hexdata = [[NSMutableData alloc] initWithCapacity:8];
//
//    NSRange ranger;
//
//    if ([string length] %2 == 0) {
//
//        ranger = NSMakeRange(0,2);
//
//    } else {
//
//        ranger = NSMakeRange(0,1);
//
//    }
//
//    for (NSInteger i = ranger.location; i < [string length]; i += 2) {
//
//        unsigned int anint;
//
//        NSString *hexStr = [string substringWithRange:ranger];
//
//        NSScanner *scan = [[NSScanner alloc] initWithString:hexStr];
//
//        [scan scanHexInt:&anint];
//
//        NSData *enty = [[NSData alloc]initWithBytes:&anint length:1];
//
//        [hexdata appendData:enty];
//
//        ranger.location += ranger.length;
//
//        ranger.length = 2;
//
//    }
//
//    return hexdata;
}

@end
