//
//  SetSelectView.m
//  HandheldBluetooth
//
//  Created by 伟 on 2018/10/25.
//  Copyright © 2018年 ZW. All rights reserved.
//

#import "SetSelectView.h"

@implementation SetSelectView

-(instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        [self creatUI];
    }
    return self;
}

-(void)creatUI{

    self.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.5f];

    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(60, self.frame.size.height/2.0f - 300/2.0f, self.frame.size.width - 60*2, 300) style:UITableViewStyleGrouped];

    if (@available(iOS 11.0, *)) {
        self.tableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;

        self.tableView.estimatedRowHeight = 0;
        self.tableView.estimatedSectionFooterHeight = 0;
        self.tableView.estimatedSectionHeaderHeight = 0;

    }

    self.tableView.backgroundColor = [UIColor whiteColor];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.bounces = NO;
    self.tableView.separatorStyle = UITableViewCellAccessoryNone;
    [self addSubview:self.tableView];
    [self.tableView registerNib:[UINib nibWithNibName:@"LeftListTableCell" bundle:nil] forCellReuseIdentifier:@"LeftListTableCell"];

    UITapGestureRecognizer *cancelTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(cancelAction)];
    cancelTap.delegate = self;
    [self addGestureRecognizer:cancelTap];
}

-(void)cancelAction{
    if (_delegate && [_delegate respondsToSelector:@selector(setViewCancelAction)]) {
        [_delegate setViewCancelAction];
    }
}

-(void)setDataArr:(NSArray *)dataArr{
    _dataArr = dataArr;
    if (dataArr.count < 6) {
        [self.tableView setFrame:CGRectMake(60, self.frame.size.height/2.0f - (50 *dataArr.count)/2.0f, self.frame.size.width - 60*2, 50 *dataArr.count)];
    }else{
        [self.tableView setFrame:CGRectMake(60, self.frame.size.height/2.0f - 300/2.0f, self.frame.size.width - 60*2, 300)];
    }
    [self.tableView reloadData];
}

#pragma mark -- UITableViewDataSource
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.dataArr.count;
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *SetViewIdentifierCell = @"SetViewIdentifierCell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:SetViewIdentifierCell];
    if (cell == nil) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:SetViewIdentifierCell];
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.contentView.backgroundColor = [UIColor whiteColor];

        UILabel *textLb = [[UILabel alloc]init];
        textLb.frame = CGRectMake(0, 0, self.frame.size.width - 60*2, 49);
        textLb.textColor = TextBlackColor;
        textLb.font = [UIFont systemFontOfSize:18];
        textLb.textAlignment = NSTextAlignmentCenter;
        textLb.tag = 10;
        [cell.contentView addSubview:textLb];

        UIView *line = [[UIView alloc]initWithFrame:CGRectMake(0, 49, cell.contentView.frame.size.width, 1)];
        line.backgroundColor = JColorFromRGB(0xd7d7d7);
        [cell.contentView addSubview:line];
    }

    UILabel *textLb = (UILabel *)[cell.contentView viewWithTag:10];
    textLb.text = self.dataArr[indexPath.row];
    return cell;
}
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    self.selectNum = indexPath.row;
    [self.tableView reloadData];
    if (_delegate && [_delegate respondsToSelector:@selector(selectRowWithNum:)]) {
        [_delegate selectRowWithNum:indexPath.row];
    }
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 50;
}
-(CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    return 0.0000000001f;
}
-(CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    return 0.0000000001f;

}

#pragma mark-手势代理，解决和tableview点击发生的冲突
-(BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldReceiveTouch:(UITouch *)touch {
    //if([touch.view isKindOfClass:[UITableView class]]){
    if ([NSStringFromClass([touch.view class]) isEqualToString:@"UITableViewCellContentView"]) {//判断如果点击的是tableView的cell，就把手势给关闭了
        return NO;//关闭手势
    }//否则手势存在
    return YES;
}

@end
