//
//  HandheldListViewController.m
//  HandheldBluetooth
//
//  Created by 伟 on 2018/10/22.
//  Copyright © 2018年 ZW. All rights reserved.
//

#import "HandheldListViewController.h"
#import "BabyBluetooth.h"
#import "HandheldListTableCell.h"

NSString *const BlueToothSearch_Not = @"BlueToothSearch_Not";

@interface HandheldListViewController ()<UITableViewDataSource,UITableViewDelegate,HandheldListDelegate,BlueToothManagerDelegate>

@property (nonatomic, strong)UITableView * tableView;

@property (nonatomic, strong) BabyBluetooth *baby;

@property (nonatomic, assign) BOOL bluetoothStateOn;   //蓝牙打开

@property (nonatomic, strong) NSMutableArray *peripheralDataArray;// 搜索到的所有设备

@property (nonatomic, strong) CBPeripheral * currentPeripheral;// 已连接的蓝牙设备

@end

@implementation HandheldListViewController

- (NSMutableArray *)peripheralDataArray {
    if (!_peripheralDataArray) {
        _peripheralDataArray = [NSMutableArray array];
    }
    return _peripheralDataArray;
}
-(BabyBluetooth *)baby{
    if (!_baby) {
        _baby = [BabyBluetooth shareBabyBluetooth];
    }
    return _baby;
}
- (void)viewDidLoad {
    [super viewDidLoad];

    [self creatUI];
//    [self initBabyBlueTooth];
    [self initNoti];
}

-(void)initNoti{

    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(changeSearchPeripherals:) name:BlueToothSearch_Not object:nil];
}

-(void)changeSearchPeripherals:(NSNotification *)not{
    
    NSString *isSearch = (NSString *)not.object;
    if ([isSearch integerValue] == 1) {
        [[BlueToothManager sharedManager] scanForPeripherals];
    }else{
        [[BlueToothManager sharedManager] stopScan];
    }

}

-(void)creatUI{

    self.view.backgroundColor = MainBackgroundColor;

    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight - 64) style:UITableViewStyleGrouped];
    if (KISIphoneX) {
        self.tableView.frame = CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight - 64 - IPHONEX_TOP_HEIGHT);
    }

    if (@available(iOS 11.0, *)) {
        self.tableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;

//        self.tableView.contentInset = UIEdgeInsetsMake(-20,0,0,0);

        self.tableView.estimatedRowHeight = 0;
        self.tableView.estimatedSectionFooterHeight = 0;
        self.tableView.estimatedSectionHeaderHeight = 0;

    }else{
        self.automaticallyAdjustsScrollViewInsets = NO;
    }

    self.tableView.backgroundColor = MainBackgroundColor;
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.bounces = NO;
    self.tableView.separatorStyle = UITableViewCellAccessoryNone;
    [self.view addSubview:self.tableView];
    [self.tableView registerNib:[UINib nibWithNibName:@"HandheldListTableCell" bundle:nil] forCellReuseIdentifier:@"HandheldListTableCell"];

    [BlueToothManager sharedManager].delegate = self;
}

//开始搜索外设
- (void)scanForPeripherals {
    //    //停止之前的连接
    [self.baby cancelAllPeripheralsConnection];
    //    //设置委托后直接可以使用，无需等待CBCentralManagerStatePoweredOn状态。
    self.baby.scanForPeripherals().begin();
}

//停止扫描
-(void)stopScan{
    [self.baby cancelScan];
}

-(void)initBabyBlueTooth{

    [[BabyBluetooth shareBabyBluetooth] setBlockOnCentralManagerDidUpdateState:^(CBCentralManager *central) {
        if (central.state == CBManagerStatePoweredOn) {
            self.bluetoothStateOn = YES;

//            [self scanForPeripherals];
        }

        if (central.state == CBManagerStatePoweredOff) {
            self.bluetoothStateOn = NO;
//            if ([self.delegate respondsToSelector:@selector(jwBluetoothManagerDisConnect)]) {
//                [self.delegate jwBluetoothManagerDisConnect];
//            }
        }
    }];

    //设置发现设service的Characteristics的委托
    [self.baby setBlockOnDiscoverCharacteristics:^(CBPeripheral *peripheral, CBService *service, NSError *error) {
        NSLog(@"===service name:%@",service.UUID);
        for (CBCharacteristic *c in service.characteristics) {
            NSLog(@"charateristic name is :%@",c.UUID);
        }
    }];

    //设置读取characteristics的委托
    [self.baby setBlockOnReadValueForCharacteristic:^(CBPeripheral *peripheral, CBCharacteristic *characteristics, NSError *error) {
        NSLog(@"1111111characteristic name:%@ value is:%@",characteristics.UUID,characteristics.value);
    }];

    //设置发现characteristics的descriptors的委托
    [self.baby setBlockOnDiscoverDescriptorsForCharacteristic:^(CBPeripheral *peripheral, CBCharacteristic *characteristic, NSError *error) {
        NSLog(@"===characteristic name:%@",characteristic.service.UUID);
        for (CBDescriptor *d in characteristic.descriptors) {
            NSLog(@"CBDescriptor name is :%@",d.UUID);
        }
    }];
    //设置读取Descriptor的委托
    [self.baby setBlockOnReadValueForDescriptors:^(CBPeripheral *peripheral, CBDescriptor *descriptor, NSError *error) {
        NSLog(@"Descriptor name:%@ value is:%@",descriptor.characteristic.UUID, descriptor.value);
    }];

    __weak typeof (self) weakSelf = self;
    [self.baby setBlockOnDiscoverToPeripherals:^(CBCentralManager *central, CBPeripheral *peripheral, NSDictionary *advertisementData, NSNumber *RSSI) {

        //        NSLog(@"peripheral : %@", peripheral.name);
        //        if ([peripheral.name hasPrefix:@"ACI"]) {
        //        }
//        [weakSelf insertTableView:peripheral advertisementData:advertisementData RSSI:RSSI callBack:^{
//            // 一直要更新设备信息，所以不能取消扫描，app在使用的时候会一直扫描
//            //                [[BabyBluetooth shareBabyBluetooth] cancelScan];
//
//            if ([weakSelf.delegate respondsToSelector:@selector(jwBluetoothManagerScanedDeviceDictionarys:)]) {
//                [weakSelf.delegate jwBluetoothManagerScanedDeviceDictionarys:weakSelf.peripheralDataArray];
//            }
//        }];

        NSLog(@"搜索到了设备:%@",peripheral.name);
        NSLog(@"搜索到了设备内容:%@",advertisementData[@"kCBAdvDataManufacturerData"]);
//        NSLog(@"搜索到了设备内容数据字符串:%@",[NSString stringWithFormat:@"%@",advertisementData[@"kCBAdvDataManufacturerData"]]);
        [weakSelf insertTableView:peripheral advertisementData:advertisementData RSSI:RSSI];

    }];

    //设置查找设备的过滤器
    [self.baby setFilterOnDiscoverPeripherals:^BOOL(NSString *peripheralName, NSDictionary *advertisementData, NSNumber *RSSI) {
        //最常用的场景是查找某一个前缀开头的设备
        //此项目用广播数据前2个字符串为 "0209" 0x0902 作为标记
//        NSData * data = [advertisementData valueForKey:@"kCBAdvDataManufacturerData"];
//        if (data != nil && data.length == 22) {
//            BOOL isSuccess = [weakSelf resolveAdvertisementData:data];
//            return isSuccess;
//        }
//        return YES;

        //最常用的场景是查找某一个前缀开头的设备
        if ([peripheralName hasPrefix:@"A100"] ) {
            return YES;
        }
            return NO;
    }];


    [self.baby setBlockOnCancelAllPeripheralsConnectionBlock:^(CBCentralManager *centralManager) {
        NSLog(@"setBlockOnCancelAllPeripheralsConnectionBlock");
    }];

    [self.baby setBlockOnCancelScanBlock:^(CBCentralManager *centralManager) {
        NSLog(@"setBlockOnCancelScanBlock");
    }];


    /*设置babyOptions

     参数分别使用在下面这几个地方，若不使用参数则传nil
     - [centralManager scanForPeripheralsWithServices:scanForPeripheralsWithServices options:scanForPeripheralsWithOptions];
     - [centralManager connectPeripheral:peripheral options:connectPeripheralWithOptions];
     - [peripheral discoverServices:discoverWithServices];
     - [peripheral discoverCharacteristics:discoverWithCharacteristics forService:service];

     该方法支持channel版本:
     [baby setBabyOptionsAtChannel:<#(NSString *)#> scanForPeripheralsWithOptions:<#(NSDictionary *)#> connectPeripheralWithOptions:<#(NSDictionary *)#> scanForPeripheralsWithServices:<#(NSArray *)#> discoverWithServices:<#(NSArray *)#> discoverWithCharacteristics:<#(NSArray *)#>]
     */

    //示例:
    //扫描选项->CBCentralManagerScanOptionAllowDuplicatesKey:忽略同一个Peripheral端的多个发现事件被聚合成一个发现事件
    //    NSDictionary *scanForPeripheralsWithOptions = @{CBCentralManagerScanOptionAllowDuplicatesKey:@YES};
    //连接设备->
    //    [baby setBabyOptionsWithScanForPeripheralsWithOptions:scanForPeripheralsWithOptions connectPeripheralWithOptions:nil scanForPeripheralsWithServices:nil discoverWithServices:nil discoverWithCharacteristics:nil];

}

- (void)connectDelegate {
    __weak typeof (self) weakSelf = self;
    //设置设备连接成功的委托,同一个baby对象，使用不同的channel切换委托回调
    [self.baby setBlockOnConnectedAtChannel:channelOnPeropheralView block:^(CBCentralManager *central, CBPeripheral *peripheral) {
        //        [SVProgressHUD showInfoWithStatus:[NSString stringWithFormat:@"设备：%@--连接成功",peripheral.name]];
        weakSelf.currentPeripheral = peripheral;

        [weakSelf.tableView reloadData];

        [MBProgressHUD hideAllHUDsForView:weakSelf.view animated:YES];
    }];

    //设置设备连接失败的委托
    [self.baby setBlockOnFailToConnectAtChannel:channelOnPeropheralView block:^(CBCentralManager *central, CBPeripheral *peripheral, NSError *error) {
        NSLog(@"设备：%@--连接失败",peripheral.name);
//        [SVProgressHUD showInfoWithStatus:[NSString stringWithFormat:@"设备：%@--连接失败",peripheral.name]];
        [MBProgressHUD showError:[NSString stringWithFormat:@"设备：%@连接失败",peripheral.name] toView:weakSelf.view];
        weakSelf.currentPeripheral = nil;

        [weakSelf.tableView reloadData];

        [MBProgressHUD hideAllHUDsForView:weakSelf.view animated:YES];
    }];

    //设置设备断开连接的委托
    [self.baby setBlockOnDisconnectAtChannel:channelOnPeropheralView block:^(CBCentralManager *central, CBPeripheral *peripheral, NSError *error) {
        NSLog(@"设备：%@--断开连接",peripheral.name);
//        [SVProgressHUD showInfoWithStatus:[NSString stringWithFormat:@"设备：%@--断开失败",peripheral.name]];
//        [MBProgressHUD showError:[NSString stringWithFormat:@"设备：%@断开连接失败",peripheral.name] toView:weakSelf.view];
        weakSelf.currentPeripheral = nil;

        [weakSelf.tableView reloadData];

        [MBProgressHUD hideAllHUDsForView:weakSelf.view animated:YES];
    }];

    //设置发现设备的Services的委托
    [self.baby setBlockOnDiscoverServicesAtChannel:channelOnPeropheralView block:^(CBPeripheral *peripheral, NSError *error) {

    }];
    //设置发现设service的Characteristics的委托
    [self.baby setBlockOnDiscoverCharacteristicsAtChannel:channelOnPeropheralView block:^(CBPeripheral *peripheral, CBService *service, NSError *error) {
        NSLog(@"===service name:%@",service.UUID);
    }];

    //设置读取characteristics的委托
    [self.baby setBlockOnReadValueForCharacteristicAtChannel:channelOnPeropheralView block:^(CBPeripheral *peripheral, CBCharacteristic *characteristics, NSError *error) {
        NSLog(@"2222222characteristic name:%@ value is:%@",characteristics.UUID,characteristics.value);

//        if ([[characteristics.UUID UUIDString] isEqualToString:@"1002"]) {
//            [weakSelf notifyCharacteristics:characteristics];
//        }
//
//        if ([[characteristics.UUID UUIDString] isEqualToString:@"1001"]) {
//            weakSelf.writeCharacteristic = characteristics;
//            if ([weakSelf.delegate respondsToSelector:@selector(jwBluetoothManagerDidConnectDevice)]) {
//                [weakSelf.delegate jwBluetoothManagerDidConnectDevice];
//            }
//        }


    }];
    //设置发现characteristics的descriptors的委托
    [self.baby setBlockOnDiscoverDescriptorsForCharacteristicAtChannel:channelOnPeropheralView block:^(CBPeripheral *peripheral, CBCharacteristic *characteristic, NSError *error) {
        NSLog(@"===characteristic name:%@",characteristic.service.UUID);
        for (CBDescriptor *d in characteristic.descriptors) {
            NSLog(@"CBDescriptor name is :%@",d.UUID);
        }
    }];
    //设置读取Descriptor的委托
    [self.baby setBlockOnReadValueForDescriptorsAtChannel:channelOnPeropheralView block:^(CBPeripheral *peripheral, CBDescriptor *descriptor, NSError *error) {
        NSLog(@"Descriptor name:%@ value is:%@",descriptor.characteristic.UUID, descriptor.value);
    }];

    //读取rssi的委托
    [self.baby setBlockOnDidReadRSSI:^(NSNumber *RSSI, NSError *error) {
        NSLog(@"setBlockOnDidReadRSSI:RSSI:%@",RSSI);
    }];

//    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(RSSIChange:) name:RSSICHANGE object:nil];

    //扫描选项->CBCentralManagerScanOptionAllowDuplicatesKey:忽略同一个Peripheral端的多个发现事件被聚合成一个发现事件
    NSDictionary *scanForPeripheralsWithOptions = @{CBCentralManagerScanOptionAllowDuplicatesKey:@YES};
    /*连接选项->
     CBConnectPeripheralOptionNotifyOnConnectionKey :当应用挂起时，如果有一个连接成功时，如果我们想要系统为指定的peripheral显示一个提示时，就使用这个key值。
     CBConnectPeripheralOptionNotifyOnDisconnectionKey :当应用挂起时，如果连接断开时，如果我们想要系统为指定的peripheral显示一个断开连接的提示时，就使用这个key值。
     CBConnectPeripheralOptionNotifyOnNotificationKey:
     当应用挂起时，使用该key值表示只要接收到给定peripheral端的通知就显示一个提
     */
    NSDictionary *connectOptions = @{CBConnectPeripheralOptionNotifyOnConnectionKey:@YES,
                                     CBConnectPeripheralOptionNotifyOnDisconnectionKey:@YES,
                                     CBConnectPeripheralOptionNotifyOnNotificationKey:@YES};

    [self.baby setBabyOptionsAtChannel:channelOnPeropheralView scanForPeripheralsWithOptions:scanForPeripheralsWithOptions connectPeripheralWithOptions:connectOptions scanForPeripheralsWithServices:nil discoverWithServices:nil discoverWithCharacteristics:nil];


}


#pragma mark -- 扫描获取设备
//插入table数据
-(void)insertTableView:(CBPeripheral *)peripheral advertisementData:(NSDictionary *)advertisementData RSSI:(NSNumber *)RSSI{

    NSArray *peripherals = [self.peripheralDataArray valueForKey:@"peripheral"];
    if(![peripherals containsObject:peripheral]) {
        // 未保存
        NSMutableDictionary *item = [[NSMutableDictionary alloc] init];
        [item setValue:peripheral forKey:@"peripheral"];
        [item setValue:RSSI forKey:@"RSSI"];
        [item setValue:advertisementData forKey:@"advertisementData"];
//        JWDeviceModel * model = [self resolveData:advertisementData[@"kCBAdvDataManufacturerData"]];
//        model.kCBAdvDataLocalName = advertisementData[@"kCBAdvDataLocalName"];
//        model.RSSI = RSSI;
//        [item setObject:model forKey:@"JWDeviceModel"];
        [self.peripheralDataArray addObject:item];
    }else {
        // 已保存
        NSUInteger index = [peripherals indexOfObject:peripheral];
        NSMutableDictionary *item = [[NSMutableDictionary alloc] init];
        [item setValue:peripheral forKey:@"peripheral"];
        [item setValue:RSSI forKey:@"RSSI"];
        [item setValue:advertisementData forKey:@"advertisementData"];

//        JWDeviceModel * model = [self resolveData:advertisementData[@"kCBAdvDataManufacturerData"]];
//        model.kCBAdvDataLocalName = advertisementData[@"kCBAdvDataLocalName"];
//        model.RSSI = RSSI;
//        [item setObject:model forKey:@"JWDeviceModel"];
        [self.peripheralDataArray replaceObjectAtIndex:index withObject:item];
    }

    [self.tableView reloadData];
}

#pragma mark -- 连接设备
- (void)connectPeripheral:(CBPeripheral *)peripheral {
    if (!peripheral || peripheral.state == CBPeripheralStateConnecting) {
        return;
    }

    [self.baby cancelScan];
    self.baby.having(peripheral).and.channel(channelOnPeropheralView).then.connectToPeripherals().discoverServices().discoverCharacteristics().readValueForCharacteristic().discoverDescriptorsForCharacteristic().readValueForDescriptors().begin();

}

- (void)disconnectPeripheral:(CBPeripheral *)peripheral {
    if (!peripheral || peripheral.state == CBPeripheralStateConnecting) {
        return;
    }
//    self.currentDevice = nil;
    self.currentPeripheral = nil;
//    self.writeCharacteristic = nil;

//    if (self.notifyCharacteristic.isNotifying) {
//        // 取消监听
//        [baby cancelNotify:self.currentPeripheral characteristic:self.notifyCharacteristic];
//    }

    [self.baby cancelPeripheralConnection:peripheral];
}

#pragma mark -- UITableViewDataSource
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return self.peripheralDataArray.count;
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return 1;
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    HandheldListTableCell *cell = [tableView dequeueReusableCellWithIdentifier:@"HandheldListTableCell" forIndexPath:indexPath];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    cell.contentView.backgroundColor = [UIColor whiteColor];
    cell.indexPath = indexPath;
    cell.delegate = self;
    if (self.peripheralDataArray.count > 0) {
        NSDictionary *dataDic = self.peripheralDataArray[indexPath.section];
        CBPeripheral *peripheral = dataDic[@"peripheral"];
        cell.nameLb.text = peripheral.name;
        if (peripheral.state == CBPeripheralStateConnecting || peripheral.state == CBPeripheralStateConnected) {
            cell.connectBtn.selected = YES;
        }else{
            cell.connectBtn.selected = NO;
        }

        NSDictionary *advertisementData = dataDic[@"advertisementData"];
        NSString *macOrignalStr = [[NSString stringWithFormat:@"%@",advertisementData[@"kCBAdvDataManufacturerData"]] stringByReplacingOccurrencesOfString:@"<" withString:@""];
        NSArray *macOrignalArr = [macOrignalStr componentsSeparatedByString:@" "];
        NSString *macFirstStr = [macOrignalArr firstObject];
        macFirstStr = [macFirstStr substringFromIndex:4];
        NSString *macTwoStr = [NSString stringWithFormat:@"%@%@",macFirstStr,macOrignalArr[1]];
        NSString *macStr = [self dealWithString:macTwoStr];
        if ([[macStr substringFromIndex:macStr.length - 1] isEqualToString:@":"]) {
            macStr = [macStr substringToIndex:macStr.length - 1];
        }

        cell.subTitleLb.text = macStr;
    }
    return cell;
}
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{

}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 70;
}
-(CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    return 10;
}
-(CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    return 0.0000000001f;
}
-(UIView *)tableView:(UITableView *)tableView viewForFooterInSection:(NSInteger)section{
    UIView *view = [UIView new];
    view.backgroundColor = MainBackgroundColor;
    return view;
}
// 自定义左滑显示编辑按钮
-(NSArray<UITableViewRowAction*>*)tableView:(UITableView *)tableView editActionsForRowAtIndexPath:(NSIndexPath *)indexPath
{

    UITableViewRowAction *rowAction = [UITableViewRowAction rowActionWithStyle:UITableViewRowActionStyleDefault
                                                                         title:Localized(@"删除") handler:^(UITableViewRowAction * _Nonnull action, NSIndexPath * _Nonnull indexPath) {
                                                                             NSLog(@"删除");
                                                                             NSDictionary *dataDic = self.peripheralDataArray[indexPath.section];
                                                                             CBPeripheral *peripheral = dataDic[@"peripheral"];
                                                                             if (peripheral.state == CBPeripheralStateConnecting || peripheral.state == CBPeripheralStateConnected) {
                                                                                 [[BlueToothManager sharedManager] disconnectPeripheral:peripheral];                      }
                                                                             [self.peripheralDataArray removeObjectAtIndex:indexPath.section];
                                                                             [self.tableView reloadData];
                                                                         }];

    //    rowAction.backgroundColor = TextGreenColor;

    NSArray *arr = @[rowAction];
    return arr;
}

//每隔2个字符添加一个:的字符串算法
- (NSString *)dealWithString:(NSString *)number
{
    NSString *doneTitle = @"";
    int count = 0;
    for (int i = 0; i < number.length; i++) {

        count++;
        doneTitle = [doneTitle stringByAppendingString:[number substringWithRange:NSMakeRange(i, 1)]];
        if (count == 2) {
            doneTitle = [NSString stringWithFormat:@"%@:", doneTitle];
            count = 0;
        }
    }
    NSLog(@"%@", doneTitle);
    return doneTitle;
}

- (NSString *)dealWithString1:(NSString *)drawNumberStr{

    NSMutableArray *muArray = [NSMutableArray array];
    for (int w = 2; w < drawNumberStr.length + 2; w ++) {
        NSString *mStr = [drawNumberStr substringToIndex:w];
        drawNumberStr = [drawNumberStr substringFromIndex:w];
        w = w - 2;
        [muArray addObject:mStr];
    }
    NSString *doneTitle = [muArray componentsJoinedByString:@":"];
    return doneTitle;
}

#pragma mark - HandheldListDelegate
-(void)clickConnectActionWithIndexPath:(NSIndexPath *)indexPath AndisSelect:(BOOL)isSelect{

    NSDictionary *dataDic = self.peripheralDataArray[indexPath.section];
    CBPeripheral *peripheral = dataDic[@"peripheral"];

//    [MBProgressHUD showHUDAddedTo:self.view animated:YES];

    if (isSelect) {
        [[BlueToothManager sharedManager] connectPeripheral:peripheral];

        NSDictionary *advertisementData = dataDic[@"advertisementData"];
        NSString *macOrignalStr = [[NSString stringWithFormat:@"%@",advertisementData[@"kCBAdvDataManufacturerData"]] stringByReplacingOccurrencesOfString:@"<" withString:@""];
        NSArray *macOrignalArr = [macOrignalStr componentsSeparatedByString:@" "];
        NSString *macFirstStr = [macOrignalArr firstObject];
        macFirstStr = [macFirstStr substringFromIndex:4];
        NSString *macTwoStr = [NSString stringWithFormat:@"%@%@",macFirstStr,macOrignalArr[1]];
        NSString *macStr = [self dealWithString:macTwoStr];
        if ([[macStr substringFromIndex:macStr.length - 1] isEqualToString:@":"]) {
            macStr = [macStr substringToIndex:macStr.length - 1];
        }

        [[NSUserDefaults standardUserDefaults] setObject:macStr forKey:@"MacAddressPeripheral_Connect"];
        [[NSUserDefaults standardUserDefaults] synchronize];

    }else{
        [[BlueToothManager sharedManager] disconnectPeripheral:peripheral];
    }

}

#pragma mark -- BlueToothManagerDelegate
-(void)getAllPeripheralWithArr:(NSArray *)peripheralArr{
    self.peripheralDataArray = [peripheralArr mutableCopy];
    [self.tableView reloadData];
}
-(void)connectStateUpdateWithShowStr:(NSString *)showStr AndIsShow:(BOOL)isShow{
    if (isShow) {
        [MBProgressHUD showError:showStr toView:self.view];
    }
    [self.tableView reloadData];
}
-(void)connectPeripheralWithState:(NSInteger)state{

    if (state == 1) {

    [[NSUserDefaults standardUserDefaults] setObject:@"1" forKey:@"NewperiPheral_Defalts"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    }
//    else{
//        [[NSUserDefaults standardUserDefaults] setObject:@"0" forKey:@"NewperiPheral_Defalts"];
//        [[NSUserDefaults standardUserDefaults] synchronize];
//    }
}

@end
