//
//  HandheldSetViewController.m
//  HandheldBluetooth
//
//  Created by 伟 on 2018/10/23.
//  Copyright © 2018年 ZW. All rights reserved.
//

#import "HandheldSetViewController.h"
#import "SetListOneTableCell.h"
#import "SetHeaderView.h"
#import "SetSelectView.h"
#import "PeripheralSetModel.h"
#import "HexHelper.h"

NSString *const BlueToothSetInfoUpdate_Not = @"BlueToothSetInfoUpdate_Not";

@interface HandheldSetViewController ()<UITableViewDataSource,UITableViewDelegate,SetListDelegate,BlueToothManagerDataDelegate,SetSelectViewDelegate>

@property (nonatomic, strong)UITableView * tableView;

@property (nonatomic, strong) SetHeaderView *headerView;

@property (nonatomic, strong) SetSelectView *selectView;

@property (nonatomic, strong) PeripheralSetModel *setModel;

@property (nonatomic, assign) NSInteger selectNum;

@property (nonatomic, strong) NSArray *numArr;  //RFID功率大小

@property (nonatomic, strong) NSArray *numArr1;  //临界值

@property (nonatomic, strong) NSArray *readSpeedArr;  // 读取速度

@property (nonatomic, strong) NSArray *reduceUnitArr;  // 减小的单位值

@property (nonatomic, strong) NSArray *volumeArr;  // 手持拍音量

@property (nonatomic, strong) NSArray *languageArr;  //语言

@end

@implementation HandheldSetViewController

-(NSArray *)languageArr{
    if (!_languageArr) {
        _languageArr = @[Localized(@"英文"),Localized(@"中文")];
    }
    return _languageArr;
}
-(NSArray *)reduceUnitArr{
    if (!_reduceUnitArr) {
        _reduceUnitArr = [NSArray array];

        NSMutableArray *numMutArr = [NSMutableArray array];
        for (NSInteger i = 1; i<7; i++) {
            [numMutArr addObject:[NSString stringWithFormat:@"%d",i]];
        }
        _reduceUnitArr = [numMutArr copy];
    }
    return _reduceUnitArr;
}
-(NSArray *)volumeArr{
    if (!_volumeArr) {
        _volumeArr = @[Localized(@"震动"),Localized(@"静音"),Localized(@"低"),Localized(@"正常"),Localized(@"高")];
    }
    return _volumeArr;
}
-(NSArray *)readSpeedArr{
    if (!_readSpeedArr) {
        _readSpeedArr = @[Localized(@"慢速"),Localized(@"标准"),Localized(@"快速")];
    }
    return _readSpeedArr;
}
-(NSArray *)numArr1{
    if (!_numArr1) {
        _numArr1 = [NSArray array];

        NSMutableArray *numMutArr = [NSMutableArray array];
        for (NSInteger i = 29; i>2; i--) {
            [numMutArr addObject:[NSString stringWithFormat:@"%ld",i]];
        }
        _numArr1 = [numMutArr copy];
    }
    return _numArr1;
}
-(NSArray *)numArr{
    if (!_numArr) {
        _numArr = [NSArray array];

        NSMutableArray *numMutArr = [NSMutableArray array];
        for (NSInteger i = 30; i>2; i--) {
            [numMutArr addObject:[NSString stringWithFormat:@"%ld",i]];
        }
        _numArr = [numMutArr copy];
    }
    return _numArr;
}
-(PeripheralSetModel *)setModel{
    if (!_setModel) {
        _setModel = [PeripheralSetModel new];
    }
    return _setModel;
}
-(SetSelectView *)selectView{
    if (!_selectView) {
        _selectView = [[SetSelectView alloc]initWithFrame:CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight)];
        _selectView.delegate = self;
        UIWindow *keyWin = [UIApplication sharedApplication].keyWindow;
        [keyWin addSubview:_selectView];
        _selectView.hidden = YES;
    }
    return _selectView;
}
- (void)viewDidLoad {
    [super viewDidLoad];

    [self creatUI];
    [self initNoti];
}

-(void)initNoti{

    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(getSetInfo:) name:BlueToothSetInfoUpdate_Not object:nil];
}

-(void)creatUI{

    self.view.backgroundColor = [UIColor whiteColor];

    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight - 64) style:UITableViewStyleGrouped];
    if (KISIphoneX) {
        self.tableView.frame = CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight - 64 - IPHONEX_TOP_HEIGHT);
    }

    if (@available(iOS 11.0, *)) {
        self.tableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;

        //        self.tableView.contentInset = UIEdgeInsetsMake(-20,0,0,0);

        self.tableView.estimatedRowHeight = 0;
        self.tableView.estimatedSectionFooterHeight = 0;
        self.tableView.estimatedSectionHeaderHeight = 0;

    }else{
        self.automaticallyAdjustsScrollViewInsets = NO;
    }

    self.tableView.backgroundColor = [UIColor whiteColor];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.bounces = NO;
    self.tableView.separatorStyle = UITableViewCellAccessoryNone;
    [self.view addSubview:self.tableView];
    [self.tableView registerNib:[UINib nibWithNibName:@"SetListOneTableCell" bundle:nil] forCellReuseIdentifier:@"SetListOneTableCell"];

    self.headerView = [[[NSBundle mainBundle] loadNibNamed:@"SetHeaderView" owner:self options:nil] lastObject];
    self.headerView.frame = CGRectMake(0, 0, KMainScreenWidth, 100);
    self.tableView.tableHeaderView = self.headerView;

    [BlueToothManager sharedManager].dataDelegate = self;
}

-(void)getSetInfo:(NSNotification *)not{

    if ([BlueToothManager sharedManager].currentPeripheral != nil) {
        self.headerView.img.image = [UIImage imageNamed:@"a100"];
        self.headerView.nameLb.text = [BlueToothManager sharedManager].currentPeripheral.name;

        self.headerView.macAddressLb.text = [[NSUserDefaults standardUserDefaults] valueForKey:@"MacAddressPeripheral_Connect"];

        [self readPeripheralSetInfo];

    }else{
        self.headerView.img.image = [UIImage imageNamed:@"ic_action_cancel"];
        self.headerView.nameLb.text = @"-";
        self.headerView.macAddressLb.text = @"00:00:00:00:00";
        self.headerView.electricityLb.text = @"100%";
    }

}

-(void)readPeripheralSetInfo{

    //    [[BlueToothManager sharedManager] readInfoData];

    //    [[BlueToothManager sharedManager] wirteData:@">i\r\n"];
    //    [[BlueToothManager sharedManager] wirteData:@"3E690D0A"];

//    NSString *AllHexStr = [NSString stringWithFormat:@">i\r\n"];
//    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:AllHexStr]];

    //MAC蓝牙地址
//        NSString *hexStr = [NSString stringWithFormat:@">y 8\r\n"];
//
//        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];
    //    [[BlueToothManager sharedManager] wirteData:@"3E7920380D0A"];

    //电池电量
    [[BlueToothManager sharedManager] wirteData:@"3E7920760D0A"];

    //RFID功率大小
    NSString *hexStr = [NSString stringWithFormat:@">y p\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

    //读取速度
    NSString *hexStr1 = [NSString stringWithFormat:@">y e\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr1]];

    //临界值
    NSString *hexStr2 = [NSString stringWithFormat:@">y k\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr2]];

    //减小的单位值
    NSString *hexStr3 = [NSString stringWithFormat:@">y u\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr3]];

    //音量
    NSString *hexStr4 = [NSString stringWithFormat:@">y s\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr4]];

    //只报告新的标签
    NSString *hexStr5 = [NSString stringWithFormat:@">y b\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr5]];

    //持续读取
    NSString *hexStr6 = [NSString stringWithFormat:@">y c\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr6]];

    //允许菜单
    NSString *hexStr7 = [NSString stringWithFormat:@">y a\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr7]];

    //语言
    NSString *hexStr8 = [NSString stringWithFormat:@">y 1\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr8]];

}

#pragma mark -- UITableViewDataSource
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return 9;
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    SetListOneTableCell *cell = [tableView dequeueReusableCellWithIdentifier:@"SetListOneTableCell" forIndexPath:indexPath];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    cell.contentView.backgroundColor = [UIColor whiteColor];
    cell.indexPath = indexPath;
    cell.delegate = self;
    if (indexPath.row == 5 || indexPath.row == 6 || indexPath.row == 7) {
        cell.switchBtn.hidden = NO;
        cell.subTextView.hidden = YES;
    }else{
        cell.switchBtn.hidden = YES;
        cell.subTextView.hidden = NO;
    }

    NSArray *textArr = @[@"RFID功率大小",@"读取速度",@"临界值",@"减小的单位值",@"RFID手持拍音量",@"只报告新的标签",@"持续读取",@"允许菜单",@"语言"];
    NSArray *imgArr = @[@"ic_action_network_cell",@"ic_action_location_searching",@"ic_action_location_searching",@"ic_action_next",@"ic_action_volume_on",@"ic_action_new",@"ic_action_refresh",@"ic_action_keyboard",@"ic_action_edit"];

    cell.textLb.text = Localized(textArr[indexPath.row]);
    cell.img.image = [UIImage imageNamed:imgArr[indexPath.row]];
    if (indexPath.row == 0) {
        cell.subTextLb.text = self.setModel.RFIDPowerNum;
    }else if (indexPath.row == 1) {
        cell.subTextLb.text = self.setModel.readSpeed;
    }else if (indexPath.row == 2) {
        cell.subTextLb.text = self.setModel.critical;
    }else if (indexPath.row == 3) {
        cell.subTextLb.text = self.setModel.reduceUnit;
    }else if (indexPath.row == 4) {
        cell.subTextLb.text = self.setModel.volume;
    }else if (indexPath.row == 5) {
        [cell.switchBtn setOn:self.setModel.isNewLabel];
    }else if (indexPath.row == 6) {
        [cell.switchBtn setOn:self.setModel.isContinueRead];
    }else if (indexPath.row == 7) {
        [cell.switchBtn setOn:self.setModel.isAllowMeau];
    }else if (indexPath.row == 8) {
        cell.subTextLb.text = self.setModel.peripheralLanguage;
    }
    return cell;
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 50;
}
-(CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    return 0.0000000001f;
}
-(CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    return 0.0000000001f;
}

#pragma mark -- SetListDelegate
-(void)clickTapWithIndexPath:(NSIndexPath *)indexPath{

    self.selectNum = indexPath.row;

    if (indexPath.row == 0) {

        self.selectView.dataArr = self.numArr;
        self.selectView.hidden = NO;
    }else if(indexPath.row == 1){
        self.selectView.dataArr = self.readSpeedArr;
        self.selectView.hidden = NO;
    }else if(indexPath.row == 2){
        self.selectView.dataArr = self.numArr1;
        self.selectView.hidden = NO;
    }else if(indexPath.row == 3){
        self.selectView.dataArr = self.reduceUnitArr;
        self.selectView.hidden = NO;
    }else if(indexPath.row == 4){
        self.selectView.dataArr = self.volumeArr;
        self.selectView.hidden = NO;
    }else if(indexPath.row == 8){
        self.selectView.dataArr = self.languageArr;
        self.selectView.hidden = NO;
    }
}
-(void)switchActionWithSelect:(BOOL)isSelect WithIndexPath:(nonnull NSIndexPath *)indexPath{
    if (indexPath.row == 5) {

        self.setModel.isNewLabel = isSelect;

        NSString *hexStr = [NSString stringWithFormat:@">x b %d\r\n",!isSelect];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];
    }else if (indexPath.row == 6) {

        self.setModel.isContinueRead = isSelect;

        NSString *hexStr = [NSString stringWithFormat:@">x c %d\r\n",isSelect];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];
    }else if (indexPath.row == 7) {

        self.setModel.isAllowMeau = isSelect;

        NSString *hexStr = [NSString stringWithFormat:@">x a %d\r\n",isSelect];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];
    }
}

#pragma mark -- SetSelectViewDelegate
-(void)selectRowWithNum:(NSInteger)selectNum{
    if (self.selectNum == 0) {

        NSString *hexStr = [NSString stringWithFormat:@">x p %ld\r\n",30 - [self.numArr[selectNum] integerValue]];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

        self.setModel.RFIDPowerNum = self.numArr[selectNum];
        [self.tableView reloadData];
    }else if (self.selectNum == 1) {

        NSString *hexStr = [NSString stringWithFormat:@">x e %ld\r\n",selectNum];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

        self.setModel.readSpeed = self.readSpeedArr[selectNum];
        [self.tableView reloadData];
    }else if (self.selectNum == 2) {

        NSString *hexStr = [NSString stringWithFormat:@">x k %ld\r\n",[self.numArr1[selectNum] integerValue]];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

        self.setModel.critical = self.numArr1[selectNum];
        [self.tableView reloadData];
    }else if (self.selectNum == 3) {

        NSString *hexStr = [NSString stringWithFormat:@">x u %ld\r\n",[self.reduceUnitArr[selectNum] integerValue]];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

        self.setModel.reduceUnit = self.reduceUnitArr[selectNum];
        [self.tableView reloadData];
    } else if (self.selectNum == 4) {

        NSString *hexStr = [NSString stringWithFormat:@">x s %ld\r\n",selectNum];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

        self.setModel.volume = self.volumeArr[selectNum];
        [self.tableView reloadData];
    }else if (self.selectNum == 8) {

        NSString *hexStr = [NSString stringWithFormat:@">x 1 %ld\r\n",selectNum];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

        self.setModel.peripheralLanguage = self.languageArr[selectNum];
        [self.tableView reloadData];

        if (selectNum == 0) {
            [InternationalControl setUserlanguage:kENGLISH];
        }else if(selectNum == 1){
            [InternationalControl setUserlanguage:kCHINESE];
        }

    }
    self.selectView.hidden = YES;
}
-(void)setViewCancelAction{
    self.selectView.hidden = YES;
}

#pragma mark -- BlueToothManagerDataDelegate
-(void)getPeripheralElectricityWithStr:(NSString *)electricityStr{

    NSArray *electricityArr = [electricityStr componentsSeparatedByString:@","];
    if (electricityArr.count > 1) {

    self.headerView.electricityLb.text = [NSString stringWithFormat:@"%@V,%ld%%",electricityArr[0],[electricityArr[1] integerValue]];
    }
}

-(void)getPeripheralRFIDPowerWithStr:(NSString *)RFIDStr{
    self.setModel.RFIDPowerNum = [NSString stringWithFormat:@"%ld",30 - [RFIDStr integerValue]];
    [self.tableView reloadData];
}

-(void)getPeripheralReadSpeedWithStr:(NSString *)speedStr{
    self.setModel.readSpeed = self.readSpeedArr[[speedStr integerValue]];
    [self.tableView reloadData];
}

-(void)getPeripheralCriticalWithStr:(NSString *)criticalStr{
    self.setModel.critical = criticalStr;
    [self.tableView reloadData];
}

-(void)getPeripheralReduceUnitWithStr:(NSString *)reduceUnitStr{
    self.setModel.reduceUnit = reduceUnitStr;
    [self.tableView reloadData];
}

-(void)getPeripheralVolumeWithStr:(NSString *)volumeStr{
    self.setModel.volume = self.volumeArr[[volumeStr integerValue]];
    [self.tableView reloadData];
}

-(void)getPeripheralNewLableWithStr:(NSString *)newLabelStr{
    if ([newLabelStr integerValue] == 1) {
        self.setModel.isNewLabel = NO;
    }else{
        self.setModel.isNewLabel = YES;
    }
    [self.tableView reloadData];
}

-(void)getPeripheralContinueReadWithStr:(NSString *)continueReadStr{
    if ([continueReadStr integerValue] == 1) {
        self.setModel.isContinueRead = YES;
    }else{
        self.setModel.isContinueRead = NO;
    }
    [self.tableView reloadData];
}

-(void)getPeripheralAllowMeauWithStr:(NSString *)allowMeauStr{
    if ([allowMeauStr integerValue] == 1) {
        self.setModel.isAllowMeau = YES;
    }else{
        self.setModel.isAllowMeau = NO;
    }
    [self.tableView reloadData];
}

-(void)getPeripheralLanguageWithStr:(NSString *)languageStr{
    self.setModel.peripheralLanguage = self.languageArr[[languageStr integerValue]];
    [self.tableView reloadData];
}

@end
