//
//  TagListViewController.m
//  HandheldBluetooth
//
//  Created by 伟 on 2018/10/26.
//  Copyright © 2018年 ZW. All rights reserved.
//

#import "TagListViewController.h"
#import "TagListHeaderView.h"
#import "TagListTableCell.h"
#import "RFIDTagListHeaderView.h"
#import "TagSearchPopView.h"
#import "SingleTagSearchView.h"
#import "RFIDDataModel.h"
#import "NSData+CRC16.h"

NSString *const TagListInfo_Not = @"TagListInfo_Not";

NSString *const TagListStart_Not = @"TagListStart_Not";
NSString *const TagListStop_Not = @"TagListStop_Not";
NSString *const TagListEmpty_Not = @"TagListEmpty_Not";

//unsigned short
#define PRESET_VALUE    0xFFFF
#define POLYNOMIAL        0x8408
unsigned short uiCrc16Cal(char * buf, unsigned int len)
{
    unsigned int ucI,ucJ;
    unsigned short  uiCrcValue = PRESET_VALUE;
    for(ucI = 0; ucI < len; ucI++)
    {
        uiCrcValue = uiCrcValue ^ *(buf + ucI);
        for(ucJ = 0; ucJ < 8; ucJ++)
        {
            if(uiCrcValue & 0x0001)
            {
                uiCrcValue = (uiCrcValue >> 1) ^ POLYNOMIAL;
            }
            else
            {
                uiCrcValue = (uiCrcValue >> 1);
            }
        }
    }
    return uiCrcValue;
}


@interface TagListViewController ()<UITableViewDataSource,UITableViewDelegate,BlueToothManagerTagListDelegate,TagSearchPopViewDelegate,SingleTagSearchViewDelegate>

@property (nonatomic, strong)UITableView * tableView;

@property (nonatomic, strong) TagListHeaderView *headerView;

@property (nonatomic, assign) BOOL isOneHeaderSelect;

@property (nonatomic, assign) BOOL isTwoHeaderSelect;

@property (nonatomic, strong) NSMutableArray *RFIDDataArr;

@property (nonatomic, strong) NSMutableArray *searchDataArr;

@property (nonatomic, strong) TagSearchPopView *searchPopView;    //通配符弹窗

@property (nonatomic, assign) BOOL isPopSearch;    //通配符搜索

@property (nonatomic, strong) NSMutableArray *wailCardSearchArr;   //通配符搜索数据

@property (nonatomic, assign) BOOL isWailcardHeaderSelect;

@property (nonatomic, strong) SingleTagSearchView *singlePopView;   //单标签弹窗

@property (nonatomic, assign) BOOL isASCIIShow;    //ASCII码显示

@property (nonatomic, strong) NSMutableArray *RFIDMoreArr;   //带模型数组

@property (nonatomic, strong) NSMutableArray *searchMoreArr;   //带模型搜索数组

@property (nonatomic, strong) NSMutableArray *wailCardMoreArr;   //带模型通配符搜索数据

@property (nonatomic, assign) BOOL isSweepYard;   //扫码

@property (nonatomic, assign) BOOL isCanSweepYard;   //是否可以扫码添加数据

@property (nonatomic, copy) NSString *totalStr;   //获取标签总数

@property (nonatomic, assign) BOOL isStop;

@property (nonatomic, assign) BOOL isCheckLabel;   //校验标签

@property (nonatomic,  copy) NSString *totalNumStr;     // >n 标签总数

@end

@implementation TagListViewController

-(SingleTagSearchView *)singlePopView{
    if (!_singlePopView) {
        _singlePopView = [[[NSBundle mainBundle]loadNibNamed:@"SingleTagSearchView" owner:self options:nil] lastObject];
        _singlePopView.frame = CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight);
        _singlePopView.delegate = self;
        UIWindow *keyWin = [UIApplication sharedApplication].keyWindow;
        [keyWin addSubview:_singlePopView];
        _singlePopView.hidden = YES;
    }
    return _singlePopView;
}
-(TagSearchPopView *)searchPopView{
    if (!_searchPopView) {
        _searchPopView = [[[NSBundle mainBundle]loadNibNamed:@"TagSearchPopView" owner:self options:nil] lastObject];
        _searchPopView.frame = CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight);
        _searchPopView.delegate = self;
        UIWindow *keyWin = [UIApplication sharedApplication].keyWindow;
        [keyWin addSubview:_searchPopView];
        _searchPopView.hidden = YES;
    }
    return _searchPopView;
}
-(NSMutableArray *)wailCardMoreArr{
    if (!_wailCardMoreArr) {
        _wailCardMoreArr = [NSMutableArray array];
    }
    return _wailCardMoreArr;
}
-(NSMutableArray *)searchMoreArr{
    if (!_searchMoreArr) {
        _searchMoreArr = [NSMutableArray array];
    }
    return _searchMoreArr;
}
-(NSMutableArray *)RFIDMoreArr{
    if (!_RFIDMoreArr) {
        _RFIDMoreArr = [NSMutableArray array];
    }
    return _RFIDMoreArr;
}
-(NSMutableArray *)wailCardSearchArr{
    if (!_wailCardSearchArr) {
        _wailCardSearchArr = [NSMutableArray array];
    }
    return _wailCardSearchArr;
}
-(NSMutableArray *)searchDataArr{
    if (!_searchDataArr) {
        _searchDataArr = [NSMutableArray array];
    }
    return _searchDataArr;
}
-(NSMutableArray *)RFIDDataArr{
    if (!_RFIDDataArr) {
        _RFIDDataArr = [NSMutableArray array];
    }
    return _RFIDDataArr;
}
-(void)dealloc{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}
- (void)viewDidLoad {
    [super viewDidLoad];

    [self creatUI];
    [self initNoti];
//    [self sendOrder];
}

-(void)creatUI{

    self.view.backgroundColor = [UIColor whiteColor];

    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight - 64) style:UITableViewStyleGrouped];
    if (KISIphoneX) {
        self.tableView.frame = CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight - 64 - IPHONEX_TOP_HEIGHT);
    }

    if (@available(iOS 11.0, *)) {
        self.tableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;

        //        self.tableView.contentInset = UIEdgeInsetsMake(-20,0,0,0);

        self.tableView.estimatedRowHeight = 0;
        self.tableView.estimatedSectionFooterHeight = 0;
        self.tableView.estimatedSectionHeaderHeight = 0;

    }else{
        self.automaticallyAdjustsScrollViewInsets = NO;
    }

    self.tableView.backgroundColor = [UIColor whiteColor];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    self.tableView.bounces = NO;
    self.tableView.separatorStyle = UITableViewCellAccessoryNone;
    [self.view addSubview:self.tableView];
    [self.tableView registerNib:[UINib nibWithNibName:@"TagListTableCell" bundle:nil] forCellReuseIdentifier:@"TagListTableCell"];

    self.headerView = [[[NSBundle mainBundle] loadNibNamed:@"TagListHeaderView" owner:self options:nil] lastObject];
    self.headerView.frame = CGRectMake(0, 0, KMainScreenWidth, 138);
    self.tableView.tableHeaderView = self.headerView;

    UITapGestureRecognizer *normalTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(normalAction)];
    [self.headerView.normalView addGestureRecognizer:normalTap];

    UITapGestureRecognizer *singleSearchTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(singleAction)];
    [self.headerView.userSearchView addGestureRecognizer:singleSearchTap];

    UITapGestureRecognizer *hexTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(hexAction)];
    [self.headerView.hexView addGestureRecognizer:hexTap];

    UITapGestureRecognizer *saveTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(saveAction)];
    [self.headerView.saveView addGestureRecognizer:saveTap];

    UITapGestureRecognizer *syncTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(syncAction)];
    [self.headerView.syncView addGestureRecognizer:syncTap];

    self.isSweepYard = YES;
    self.isCanSweepYard = YES;

    [BlueToothManager sharedManager].tagListDelegate = self;
}

-(void)initNoti{

//    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(getInfoAction:) name:TagListInfo_Not object:nil];

    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(startAction:) name:TagListStart_Not object:nil];
    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(stopAction:) name:TagListStop_Not object:nil];
    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(emptyAction:) name:TagListEmpty_Not object:nil];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(getReadState) name:@"PeripheralConnectSuccess_Not" object:nil];
}

-(void)getInfoAction:(NSNotification *)not{

    NSString *isNewOne = [[NSUserDefaults standardUserDefaults] valueForKey:@"NewperiPheral_Defalts"];

    if ([isNewOne integerValue] == 1) {

    self.isPopSearch = NO;

    NSString *hexStr2 = [NSString stringWithFormat:@">x m 0\r\n"];

    [[BlueToothManager sharedManager] wirteTagListSearchData:[HexHelper stingToHexadecimal:hexStr2]];

    NSString *hexStr1 = [NSString stringWithFormat:@">f\r\n"];

    [[BlueToothManager sharedManager] wirteTagListSearchData:[HexHelper stingToHexadecimal:hexStr1]];

        [[NSUserDefaults standardUserDefaults] setObject:@"0" forKey:@"NewperiPheral_Defalts"];
        [[NSUserDefaults standardUserDefaults] synchronize];

    }
}

-(void)getReadState{

    //读取类型
    NSString *hexStr = [NSString stringWithFormat:@">y 6\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];


    self.isStop = YES;
    self.totalStr = @"";

    self.totalNumStr = nil;

    //标签缓存列表
    NSString *hexStr1 = [NSString stringWithFormat:@">y t\r\n"];

    [[BlueToothManager sharedManager] wirteTagListSearchData:[HexHelper stingToHexadecimal:hexStr1]];
}

//开始
-(void)startAction:(NSNotification *)not{

    self.isPopSearch = NO;

//    NSString *hexStr = [NSString stringWithFormat:@">y m\r\n"];
//
//    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

//    NSString *hexStr2 = [NSString stringWithFormat:@">x m 0\r\n"];
//
//    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr2]];

//    NSString *hexStr = [NSString stringWithFormat:@">x l 901 E200100183030XXXXXXXXXXX\r\n"];
//
//    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

    NSString *hexStr1 = [NSString stringWithFormat:@">f\r\n"];

    [[BlueToothManager sharedManager] wirteTagListContinueSearchData:[HexHelper stingToHexadecimal:hexStr1]];

    self.isStop = NO;
    self.totalStr = @"";

    self.totalNumStr = nil;
}
//结束
-(void)stopAction:(NSNotification *)not{

//    sleep(3);

    NSString *hexStr = [NSString stringWithFormat:@"3\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];


    self.isStop = YES;
    self.totalStr = @"";

    self.totalNumStr = nil;

    //标签缓存列表
    NSString *hexStr1 = [NSString stringWithFormat:@">y t\r\n"];

    [[BlueToothManager sharedManager] wirteTagListSearchData:[HexHelper stingToHexadecimal:hexStr1]];

//    sleep(3);

}
//清空
-(void)emptyAction:(NSNotification *)not{

    self.isPopSearch = NO;

    self.isStop = NO;
    self.totalStr = @"";

    self.totalNumStr = nil;

    [self.RFIDDataArr removeAllObjects];
    [self.RFIDMoreArr removeAllObjects];
    [self.searchDataArr removeAllObjects];
    [self.searchMoreArr removeAllObjects];
    [self changeHeaderCountNum];
    [self.tableView reloadData];

    NSString *hexStr = [NSString stringWithFormat:@">c\r\n"];

    [[BlueToothManager sharedManager] wirteTagListSearchData:[HexHelper stingToHexadecimal:hexStr]];
}
//保存
-(void)saveAction{

    if (self.isPopSearch) {

        if (self.wailCardSearchArr.count > 0) {

        NSString *filePath = [NSHomeDirectory() stringByAppendingPathComponent:@"/Documents/HandheldBluetooth.txt"];

        BOOL isWrite = [[self.wailCardSearchArr copy] writeToFile:filePath atomically:YES];

        if (isWrite) {
            [MBProgressHUD showSuccess:Localized(@"保存成功") toView:self.view];
        }
        }

    }else{

        if (self.RFIDDataArr.count > 0) {

        NSString *filePath = [NSHomeDirectory() stringByAppendingPathComponent:@"/Documents/HandheldBluetooth.txt"];

        BOOL isWrite = [[self.RFIDDataArr copy] writeToFile:filePath atomically:YES];

        if (isWrite) {
            [MBProgressHUD showSuccess:Localized(@"保存成功") toView:self.view];
        }
        }
    }

}

-(void)syncAction{

    self.isCheckLabel = YES;

    self.isPopSearch = NO;
    self.isStop = NO;
    self.totalStr = @"";

    /*******可选代码（显示从无到有的效果）******/
    self.totalNumStr = nil;
    [self.RFIDDataArr removeAllObjects];
    [self.RFIDMoreArr removeAllObjects];
    [self.tableView reloadData];  /****/

    NSString *hexStr = [NSString stringWithFormat:@">y t s 0\r\n"];

    [[BlueToothManager sharedManager] wirteTagListSearchData:[HexHelper stingToHexadecimal:hexStr]];

}

//-(void)sendOrder{
//
////    NSString *hexStr = [NSString stringWithFormat:@">y m\r\n"];
////
////    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];
//
//    NSString *hexStr = [NSString stringWithFormat:@">x l 901 E200100183030XXXXXXXXXXX\r\n"];
//
//    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];
//
//    NSString *hexStr1 = [NSString stringWithFormat:@">f\r\n"];
//
//    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr1]];
//}

-(void)normalAction{

    self.isPopSearch = NO;

    self.isStop = NO;
    self.totalStr = @"";

    self.totalNumStr = nil;

    [self.RFIDDataArr removeAllObjects];
    [self.RFIDMoreArr removeAllObjects];
    [self.searchDataArr removeAllObjects];
    [self.searchMoreArr removeAllObjects];
    [self changeHeaderCountNum];
    [self.tableView reloadData];

    self.isCanSweepYard = YES;

    NSString *hexStr = [NSString stringWithFormat:@">x l c\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

    NSString *hexStr2 = [NSString stringWithFormat:@">x m 0\r\n"];

    [[BlueToothManager sharedManager] wirteTagListSearchData:[HexHelper stingToHexadecimal:hexStr2]];
}

-(void)singleAction{
    self.singlePopView.UIDTextField.text = @"";
    self.singlePopView.hidden = NO;
}

-(void)hexAction{
    self.isASCIIShow = !self.isASCIIShow;
    if (self.isASCIIShow) {
        self.headerView.hexHoldLb.text = Localized(@"ASC II码");
    }else{
        self.headerView.hexHoldLb.text = Localized(@"十六进制");
    }
    [self.tableView reloadData];
}

-(void)changeHeaderCountNum{

    /*

    NSLog(@"changeHeaderHeaderHeaderHeader");

//    if (self.isPopSearch) {
//        self.headerView.allNumLb.text = [NSString stringWithFormat:@"%@: %ld",Localized(@"搜索总数"),self.wailCardMoreArr.count];
//    }else{
//    self.headerView.allNumLb.text = [NSString stringWithFormat:@"%@: %ld",Localized(@"搜索总数"),self.RFIDMoreArr.count + self.searchMoreArr.count];
//    }

//    NSString * str1= @">T16010562,1";
//    const char * c1 =[str1 UTF8String];

//    char myChar = '>T16010562,1';
//    NSString * string = [NSString stringWithFormat:@"%c", myChar];

//    uiCrc16Cal(c1,10);

//    NSString *ocString = @">T16010562,1";

//    const char *charString = NULL;
//
//    if ([ocString canBeConvertedToEncoding:NSUTF8StringEncoding]) {
//
//            charString = [ocString cStringUsingEncoding:NSUTF8StringEncoding];
//
//        }

//    unsigned
    char * charStr = "16010562,1";
//
//    const char* p = (const char*)(char*)charStr;

//    [NSString stringWithUTF8String:<#(nonnull const char *)#>]


//    unsigned char Writebuf = uiCrc16Cal(charStr,10);

    uint16_t charhsta = charStr[5];

    unsigned short Writebuf = uiCrc16Cal(charStr,10);

    char * lastChar = (char *)Writebuf;

    NSLog(@"Writebuf ==== %c",Writebuf);

//    CString str1;
//
//    str1.Format("%s",Writebuf);
//
//    const char* str2=(LPCTSTR)str1;
//
//    NSLog(@"88889999 ===== %hu",uiCrc16Cal(charStr,10));
//
//    const char *p = "48254";

    NSLog(@"str ======= %@",[NSString stringWithUTF8String:charStr]);


//    NSString *hexstr = @"31363031303536322C31";
    NSString *hexstr = @"31363031303530382C31";
    NSData *dataStr = [HexHelper convertHexStrToData:hexstr];
    NSData *crcData = [dataStr crc16];
//    NSString *hexS = [HexHelper toString:crcData];
    NSString *hexS = [crcData hexadecimalString];
    NSLog(@"hexS ===== %@",hexS);
    NSString *acciiStr = [HexHelper toASCIIString:hexS];
    NSLog(@"acciiStr ===== %@",acciiStr);

     */
}

/**
 CRC16校验

 @param originStr 十六进制字符串
 @return 经过CRC16校验后的十六进制字符串
 */
-(NSString *)CRC16CheckWithOriginalStr:(NSString *)originStr{

    NSData *dataStr = [HexHelper convertHexStrToData:originStr];
    NSData *crcData = [dataStr crc16];
    NSString *hexS = [crcData hexadecimalString];
//    NSLog(@"hexS ===== %@",hexS);
//    NSString *acciiStr = [HexHelper toASCIIString:hexS];
//    NSLog(@"acciiStr ===== %@",acciiStr);
    return hexS;
}

#pragma mark -- UITableViewDataSource
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    if ((self.searchDataArr.count <= 0 && self.RFIDDataArr.count <= 0 )&& (self.wailCardMoreArr.count <= 0 && self.wailCardSearchArr.count <= 0)) {
        return 0;
    }
    if (self.isPopSearch) {
        return 1;
    }
    if (self.searchDataArr.count > 0) {
        return 2;
    }else{
        return 1;
    }
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    if (self.isPopSearch) {
        if (self.isWailcardHeaderSelect) {
            return 0;
        }else{
            return self.wailCardMoreArr.count;
        }
    }else{
    if (section == 0) {
        if (self.isOneHeaderSelect) {
            return 0;
        }else{
        return self.RFIDMoreArr.count;
        }
    }else{
        if (self.isTwoHeaderSelect) {
            return 0;
        }else{
        return self.searchMoreArr.count;
        }
    }
    }
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    TagListTableCell *cell = [tableView dequeueReusableCellWithIdentifier:@"TagListTableCell" forIndexPath:indexPath];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    cell.contentView.backgroundColor = [UIColor whiteColor];
    if (self.isPopSearch && self.wailCardMoreArr.count > 0) {

        RFIDDataModel *model = self.wailCardMoreArr[indexPath.row];

        if (self.isASCIIShow) {
            cell.numLb.text = [HexHelper toASCIIString:model.HEX];
        }else{
        cell.numLb.text = model.HEX;
        }
        cell.rightNumLb.text = [NSString stringWithFormat:@"%ld",model.num];
    }else{
    if (indexPath.section == 0 && self.RFIDMoreArr.count > 0) {

        RFIDDataModel *model = self.RFIDMoreArr[indexPath.row];

        if (self.isASCIIShow) {
            cell.numLb.text = [HexHelper toASCIIString:model.HEX];
        }else{
        cell.numLb.text = model.HEX;
        }
        cell.rightNumLb.text = [NSString stringWithFormat:@"%ld",model.num];
    }else if(indexPath.section == 1 && self.searchMoreArr.count > 0){

        RFIDDataModel *model = self.searchMoreArr[indexPath.row];

        if (self.isASCIIShow) {
            cell.numLb.text = [HexHelper toASCIIString:model.HEX];
        }else{
        cell.numLb.text = model.HEX;
        }
        cell.rightNumLb.text = [NSString stringWithFormat:@"%ld",indexPath.row + 1];
    }
    }
    return cell;
}
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{

    if (self.isPopSearch) {
        return;
    }

    if (indexPath.section == 0) {

        NSString *hexStr = [NSString stringWithFormat:@"3\r\n"];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

        [self isSearchRepeatStr:indexPath];

    }else if(indexPath.section == 1){
        self.searchPopView.indexPath = indexPath;
        self.searchPopView.UIDTextField.text = self.searchDataArr[indexPath.row];
        self.searchPopView.hidden = NO;
    }
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 50;
}
-(UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section{
    RFIDTagListHeaderView *topView = [[[NSBundle mainBundle] loadNibNamed:@"RFIDTagListHeaderView" owner:self options:nil] lastObject];
    topView.frame = CGRectMake(0, 0, KMainScreenWidth, 60);
    if (self.isPopSearch) {
        topView.textLb.text = Localized(@"状态");
        if (self.isWailcardHeaderSelect) {
            topView.img.image = [UIImage imageNamed:@"ic_action_collapse"];
        }else{
            topView.img.image = [UIImage imageNamed:@"ic_action_expand"];
        }
        if (self.totalNumStr.length > 0) {
            topView.rightNumLb.text = self.totalNumStr;
        }else{
        topView.rightNumLb.text = [NSString stringWithFormat:@"%ld",self.wailCardMoreArr.count];
        }
    }else{
    if (section == 0) {
        topView.textLb.text = Localized(@"RFID标签列表");
        if (self.isOneHeaderSelect) {
            topView.img.image = [UIImage imageNamed:@"ic_action_collapse"];
        }else{
            topView.img.image = [UIImage imageNamed:@"ic_action_expand"];
        }

//        NSArray *titleArr = [self.headerView.allNumLb.text componentsSeparatedByString:@": "];
//
//        if ([[titleArr lastObject] integerValue] == self.RFIDMoreArr.count) {

        if (self.totalNumStr.length > 0) {
            topView.rightNumLb.text = self.totalNumStr;
        }else{
        topView.rightNumLb.text = [NSString stringWithFormat:@"%ld",self.RFIDMoreArr.count];
        }
//        }else{
//            topView.rightNumLb.text = [NSString stringWithFormat:@"%ld",[[titleArr lastObject] integerValue] - self.searchMoreArr.count];
//        }
    }else if (section == 1){
        topView.textLb.text = Localized(@"搜索标签列表");
        if (self.isTwoHeaderSelect) {
            topView.img.image = [UIImage imageNamed:@"ic_action_collapse"];
        }else{
            topView.img.image = [UIImage imageNamed:@"ic_action_expand"];
        }
        if (self.totalNumStr.length > 0) {
            topView.rightNumLb.text = self.totalNumStr;
        }else{
        topView.rightNumLb.text = [NSString stringWithFormat:@"%ld",self.searchMoreArr.count];
        }

    }
    }
    topView.tag = 100 + section;
    topView.userInteractionEnabled = YES;
    UITapGestureRecognizer *headerTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(headerTapAction:)];
    [topView addGestureRecognizer:headerTap];
    return topView;
}
-(CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    return 0.0000000001f;
}
-(CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    return 60;
}

-(void)headerTapAction:(UITapGestureRecognizer *)tap{
    if (tap.view.tag == 100) {
        if (self.isPopSearch) {
            self.isWailcardHeaderSelect = !self.isWailcardHeaderSelect;
        }else{
        self.isOneHeaderSelect = !self.isOneHeaderSelect;
        }
    }else if (tap.view.tag == 101){
        self.isTwoHeaderSelect = !self.isTwoHeaderSelect;
    }
    [self.tableView reloadData];
}

-(void)isSearchRepeatStr:(NSIndexPath *)indexPath{

//    if (self.searchDataArr.count <= 0) {
        [self.searchDataArr addObject:self.RFIDDataArr[indexPath.row]];
        [self.searchMoreArr addObject:self.RFIDMoreArr[indexPath.row]];
        [self.RFIDDataArr removeObjectAtIndex:indexPath.row];
        [self.RFIDMoreArr removeObjectAtIndex:indexPath.row];
        [self.tableView reloadData];
//    }else{
//
//    NSString *tagStr = self.RFIDDataArr[indexPath.row];
//
//    for (NSInteger i = 0; i<self.searchDataArr.count; i++) {
//
//        NSString *thanStr = self.searchDataArr[i];
//        if ([thanStr isEqualToString:tagStr]) {
//            return;
//        }
//
//        if (i == self.searchDataArr.count - 1) {
//            [self.searchDataArr addObject:self.RFIDDataArr[indexPath.row]];
//            [self.RFIDDataArr removeObjectAtIndex:indexPath.row];
//            [self.tableView reloadData];
//            return;
//        }
//    }
//    }
}

#pragma mark -- BlueToothManagerTagListDelegate

//获取标签列表数据
-(void)getTagListWithStr:(NSString *)tagListHexStr{

//    NSLog(@"tagListHexStr ===== %@",tagListHexStr);

        // 同步到主线程

    if (tagListHexStr.length > 4) {

    if (![[tagListHexStr substringWithRange:NSMakeRange(tagListHexStr.length - 4, 4)] isEqualToString:@"0D0A"]) {
        return;
    }
    }else{
        return;
    }


    NSArray *dealArr = [tagListHexStr componentsSeparatedByString:@"0D0A"];

    if (dealArr.count <= 0) {
        return;
    }

    if (self.isCheckLabel) {

        NSString *hexstr = [dealArr firstObject];

        NSString * overString = [hexstr substringWithRange:NSMakeRange(0, 6)];
        if ([overString isEqualToString:@"3E4133"] || [overString isEqualToString:@"3E4166"]) {
            self.isCheckLabel = NO;
        }

        if (hexstr.length >= 8) {
            NSString * prefixString = [hexstr substringWithRange:NSMakeRange(0, 4)];

            if ([prefixString isEqualToString:@"3E54"]){

                NSString * formalString = [hexstr substringWithRange:NSMakeRange(4, hexstr.length - 4)];
                NSString * ASCIIStr = [HexHelper toASCIIString:formalString];

                NSLog(@"isCheckLabelisASCIIStr ==== %@",ASCIIStr);

                NSArray *arr1 = [ASCIIStr componentsSeparatedByString:@","];

                if (arr1.count < 2) {
                    return;
                }

                NSArray *arr2 = [[arr1 lastObject] componentsSeparatedByString:@":"];

                if (arr2.count < 2) {
                    return;
                }

                NSString *labelStr = [arr1 firstObject];
                NSString *numberStr = [arr2 firstObject];
                NSString *checkStr = [arr2 lastObject];

                NSArray *checkArr = [formalString componentsSeparatedByString:@"3A"];

                if (checkArr.count < 2) {
                    return;
                }

                NSString *afterCheckStr = [self CRC16CheckWithOriginalStr:[NSString stringWithFormat:@"%@",[checkArr firstObject]]];
                if ([[afterCheckStr lowercaseString] isEqualToString:[checkStr lowercaseString]]) {

                    if ([numberStr integerValue] == 1) {
                        [self.RFIDDataArr removeAllObjects];
                        [self.RFIDMoreArr removeAllObjects];
                    }

                    if ([self checkSameHEXCode:labelStr AndDataArr:[self.RFIDDataArr copy]]) {

                        for (NSInteger i = 0; i<self.RFIDMoreArr.count; i++) {

                            RFIDDataModel *model = self.RFIDMoreArr[i];

                            if ([model.HEX isEqualToString:labelStr]) {
                                model.num = model.num + 1;
                                break;
                            }
                        }


                    }else{

                        [self.RFIDDataArr addObject:labelStr];

                        RFIDDataModel *model = [RFIDDataModel new];
                        model.HEX = labelStr;
                        model.num = 1;
                        [self.RFIDMoreArr addObject:model];

                    }

                    NSString *hexStr111 = [NSString stringWithFormat:@">y t s %@\r\n",numberStr];

                    NSLog(@"hexStr111 ==== %@",hexStr111);

                    [[BlueToothManager sharedManager] wirteTagListSearchData:[HexHelper stingToHexadecimal:hexStr111]];

                }else{
                    return;
                }

                dispatch_async(dispatch_get_main_queue(), ^{

                    if (self.RFIDDataArr.count > 0 && self.RFIDMoreArr.count > 0) {

                        /*******可选代码（显示从无到有的效果）*******/
                        if (self.totalNumStr.length <= 0) {

                            self.headerView.allNumLb.text = [NSString stringWithFormat:@"%@: %ld",Localized(@"搜索总数"),self.RFIDDataArr.count];
                        }   /******/

                        [self.searchDataArr removeAllObjects];
                        //                    if (!isTotal) {
                        [self changeHeaderCountNum];
                        //                    }
                        [self.tableView reloadData];
                    }

                });


            }
        }

    }else{

    if (dealArr.count > 1) {

        self.isCanSweepYard = NO;

        NSOperationQueue *waitQueue = [[NSOperationQueue alloc] init];
        [waitQueue addOperationWithBlock:^{

//        [self.RFIDDataArr removeAllObjects];
//        [self.RFIDMoreArr removeAllObjects];

        NSMutableArray *mutArr = [NSMutableArray array];
        NSMutableArray *moreArr = [NSMutableArray array];
        for (NSInteger i = 0; i<dealArr.count; i++) {
            NSString *hexstr = dealArr[i];

//            if (hexstr.length > 4) {
//
//                NSString * prefixString = [hexstr substringWithRange:NSMakeRange(0, 4)];
//
//                if ([prefixString isEqualToString:@"3E6E"]) {
//                    NSString * formalString1 = [hexstr substringWithRange:NSMakeRange(6, hexstr.length - 6 - 4)];
//                    NSString * ASCIIStr1 = [HexHelper toASCIIString:formalString1];
//
////                    self.headerView.allNumLb.text = [NSString stringWithFormat:@"%@: %@",Localized(@"搜索总数"),ASCIIStr1];
//
//                }
//
//            }

            //15
            if (hexstr.length >= 8) {

                NSString * prefixString = [hexstr substringWithRange:NSMakeRange(0, 4)];

                if ([prefixString isEqualToString:@"3E6E"] || [prefixString isEqualToString:@"3E4E"]){
                    NSString * formalString = [hexstr substringWithRange:NSMakeRange(6, hexstr.length - 6)];
                    NSString * ASCIIStr = [HexHelper toASCIIString:formalString];

                    dispatch_async(dispatch_get_main_queue(), ^{
                        self.headerView.allNumLb.text = [NSString stringWithFormat:@"%@: %@",Localized(@"搜索总数"),ASCIIStr];

                        self.totalNumStr = [NSString stringWithFormat:@"%@",ASCIIStr];

//                        NSLog(@"222222ASCIIStr ==== %@,formalString ===== %@,hexstr ===== %@,hexstr.length === %ld",ASCIIStr,formalString,hexstr,hexstr.length);
                    });
                    continue;
                }

                if (![prefixString isEqualToString:@"3E54"] && ![prefixString isEqualToString:@"3E4A"]) {
                    continue;
                }


                NSString * overString = [hexstr substringWithRange:NSMakeRange(0, 6)];

                if ([overString isEqualToString:@"3E4133"]) {
                    self.isCheckLabel = NO;
                    continue;
                }


                NSString * formalString = [hexstr substringWithRange:NSMakeRange(4, hexstr.length - 4)];
                NSString * ASCIIStr = [HexHelper toASCIIString:formalString];

//                [self getHEXCode:ASCIIStr];

                if ([self checkSameHEXCode:ASCIIStr AndDataArr:[mutArr copy]]) {

                    for (NSInteger i = 0; i<moreArr.count; i++) {

                        RFIDDataModel *model = moreArr[i];

                        if ([model.HEX isEqualToString:ASCIIStr]) {
                            model.num = model.num + 1;
                            break;
                        }
                    }


                }else{

                    [mutArr addObject:ASCIIStr];

                    RFIDDataModel *model = [RFIDDataModel new];
                    model.HEX = ASCIIStr;
                    model.num = 1;
                    [moreArr addObject:model];

                }

//                if (mutArr.count > 0) {
//                    for (NSInteger i = 0; i<mutArr.count; i++) {
//                        NSString *sourceStr = mutArr[i];
//                        if ([ASCIIStr isEqualToString:sourceStr]) {
//                            RFIDDataModel *model = moreArr[i];
//                            model.num = model.num + 1;
//                        }
//                        if (i == mutArr.count - 1) {
//
//                            [mutArr addObject:ASCIIStr];
//
//                            RFIDDataModel *model = [RFIDDataModel new];
//                            model.HEX = ASCIIStr;
//                            model.num = 1;
//                            [moreArr addObject:model];
//
//                        }
//                    }
//                }else{
//                    [mutArr addObject:ASCIIStr];
//
//                    RFIDDataModel *model = [RFIDDataModel new];
//                    model.HEX = ASCIIStr;
//                    model.num = 1;
//                    [moreArr addObject:model];
//                }
            }
        }

            dispatch_async(dispatch_get_main_queue(), ^{

//                BOOL isTotal = NO;
//
//                NSString *lastStr = dealArr[dealArr.count - 2];
//                if (lastStr.length > 4) {
//
//                    NSString * prefixString = [lastStr substringWithRange:NSMakeRange(0, 4)];
//
//                    NSLog(@"lastStr ====== %@",lastStr);
//
//                    if ([prefixString isEqualToString:@"3E6E"]) {
//                        NSString * formalString1 = [lastStr substringWithRange:NSMakeRange(6, lastStr.length - 6)];
//                        NSString * ASCIIStr1 = [HexHelper toASCIIString:formalString1];
//
//                        self.headerView.allNumLb.text = [NSString stringWithFormat:@"%@: %@",Localized(@"搜索总数"),ASCIIStr1];
//
//                        isTotal = YES;
//
//                        NSLog(@"搜索总数 ====== %@",ASCIIStr1);
//                    }
//
//                }

                if (mutArr.count > 0 && moreArr.count > 0) {
                    if (self.isPopSearch) {
                        self.wailCardSearchArr = mutArr;
                        self.wailCardMoreArr = moreArr;
                    }else{
                    self.RFIDDataArr = mutArr;
                    self.RFIDMoreArr = moreArr;
                    }
                    [self.searchDataArr removeAllObjects];
//                    if (!isTotal) {
                    [self changeHeaderCountNum];
//                    }
                    [self.tableView reloadData];
                }

            });
        }];
    }
    }
}

//-(void)getHEXCode:(NSString *)ASCIIStr{
//
//    if (self.RFIDDataArr.count > 0) {
//        for (NSInteger i = 0; i<self.RFIDDataArr.count; i++) {
//            NSString *sourceStr = self.RFIDDataArr[i];
//            if ([ASCIIStr isEqualToString:sourceStr]) {
//                RFIDDataModel *model = self.RFIDMoreArr[i];
//                model.num = model.num + 1;
//            }
//            if (i == self.RFIDDataArr.count - 1) {
//
//                [self.RFIDDataArr addObject:ASCIIStr];
//
//                RFIDDataModel *model = [RFIDDataModel new];
//                model.HEX = ASCIIStr;
//                model.num = 1;
//                [self.RFIDMoreArr addObject:model];
//
//            }
//        }
//    }else{
//        [self.RFIDDataArr addObject:ASCIIStr];
//
//        RFIDDataModel *model = [RFIDDataModel new];
//        model.HEX = ASCIIStr;
//        model.num = 1;
//        [self.RFIDMoreArr addObject:model];
//    }
//
//}

-(BOOL)checkSameHEXCode:(NSString *)HEXStr AndDataArr:(NSArray *)dataArr{

    if (dataArr.count <= 0) {
        return NO;
    }

    for (NSInteger i = 0; i<dataArr.count; i++) {
        NSString *sourceStr = dataArr[i];
        if ([HEXStr isEqualToString:sourceStr]) {
            return YES;
        }
    }
    return NO;
}

//获取标签列表数据(清空后)
-(void)getClearTagListWithStr:(NSString *)tagListASCIIStr{

    NSLog(@"clearclearclearclearclearclear");

    self.isCanSweepYard = NO;

    self.isStop = NO;
    self.totalStr = @"";

    self.totalNumStr = nil;

    [self.RFIDDataArr addObject:tagListASCIIStr];
    [self changeHeaderCountNum];
    [self.tableView reloadData];
}

//通配符搜索数据
-(void)getWailcardTagListWithStr:(NSString *)tagListWailcardASCIIStr{

    self.isPopSearch = YES;

    if (self.wailCardSearchArr.count > 0) {

        for (NSInteger i = 0; i<self.wailCardSearchArr.count; i++) {
            NSString *hexStr = self.wailCardSearchArr[i];
            if ([hexStr isEqualToString:tagListWailcardASCIIStr]) {
                if (self.wailCardMoreArr.count >= i) {
                    RFIDDataModel *model = self.wailCardMoreArr[i];
                    model.num = model.num + 1;
                    break;
                }
            }
            if (i == self.wailCardSearchArr.count - 1) {

                [self.wailCardSearchArr addObject:tagListWailcardASCIIStr];

                RFIDDataModel *model = [RFIDDataModel new];
                model.HEX = tagListWailcardASCIIStr;
                model.num = 1;
                [self.wailCardMoreArr addObject:model];
                break;
            }
        }

    }else{
    [self.wailCardSearchArr addObject:tagListWailcardASCIIStr];

        RFIDDataModel *model = [RFIDDataModel new];
        model.HEX = tagListWailcardASCIIStr;
        model.num = 1;
        [self.wailCardMoreArr addObject:model];

    }
    [self changeHeaderCountNum];
    [self.tableView reloadData];
}

/**
 扫码

 @param HEXStr <#HEXStr description#>
 */
-(void)getSweepYardWithStr:(NSString *)HEXStr{

    if (self.isSweepYard && self.isCanSweepYard) {

        self.isPopSearch = NO;

        self.isStop = NO;
        self.totalStr = @"";

        self.totalNumStr = nil;

    if (self.RFIDDataArr.count > 0) {

        for (NSInteger i = 0; i<self.RFIDDataArr.count; i++) {
            NSString *hexStr = self.RFIDDataArr[i];
            if ([hexStr isEqualToString:HEXStr]) {
                if (self.RFIDMoreArr.count >= i) {
                    RFIDDataModel *model = self.RFIDMoreArr[i];
                    model.num = model.num + 1;
                    break;
                }
            }
            if (i == self.RFIDDataArr.count - 1) {

                [self.RFIDDataArr addObject:HEXStr];

                RFIDDataModel *model = [RFIDDataModel new];
                model.HEX = HEXStr;
                model.num = 1;
                [self.RFIDMoreArr addObject:model];
                break;
            }
        }

    }else{
        [self.RFIDDataArr addObject:HEXStr];

        RFIDDataModel *model = [RFIDDataModel new];
        model.HEX = HEXStr;
        model.num = 1;
        [self.RFIDMoreArr addObject:model];

    }
    [self changeHeaderCountNum];
    [self.tableView reloadData];

    }

}

-(void)ScavengingState:(BOOL)isSweep{
    if (isSweep && self.isCanSweepYard) {
        self.isSweepYard = YES;
    }else{
        self.isSweepYard = NO;
    }
}


/**
 读取类型

 @param typeStr <#typeStr description#>
 */
-(void)getReadType:(NSString *)typeStr{
    if ([typeStr integerValue] == 2) {
        self.isSweepYard = YES;
        self.isCanSweepYard = YES;
    }else{
        self.isSweepYard = NO;
        self.isCanSweepYard = NO;
    }
}

//清空搜索列表通知
-(void)clearSearchListNot{

    if (self.wailCardSearchArr.count > 0) {

    self.isPopSearch = NO;
    }

    self.isStop = NO;
    self.totalStr = @"";

    self.totalNumStr = nil;

    [self.RFIDDataArr removeAllObjects];
    [self.RFIDMoreArr removeAllObjects];
    [self.searchDataArr removeAllObjects];
    [self.searchMoreArr removeAllObjects];
    [self.wailCardSearchArr removeAllObjects];
    [self.wailCardMoreArr removeAllObjects];
    [self changeHeaderCountNum];
    [self.tableView reloadData];

    self.isCanSweepYard = YES;
}

/**
 //获取全部标签数量值

 @param totalStr <#totalStr description#>
 */
-(void)getTagListTotal:(NSString *)totalStr{

    NSLog(@"搜索总数 ===== %@",totalStr);

//    if (self.isPopSearch) {
    self.headerView.allNumLb.text = [NSString stringWithFormat:@"%@: %@",Localized(@"搜索总数"),totalStr];
//    }else{
//        self.headerView.allNumLb.text = [NSString stringWithFormat:@"%@: %ld",Localized(@"搜索总数"),self.RFIDMoreArr.count + self.searchMoreArr.count];
//    }

    self.totalNumStr = totalStr;
    [self.tableView reloadData];

}

/**
 暂停
 */
-(void)getStopOrder{

    self.isStop = YES;
    self.totalStr = @"";

    self.totalNumStr = nil;

    //标签缓存列表
    NSString *hexStr1 = [NSString stringWithFormat:@">y t\r\n"];

    [[BlueToothManager sharedManager] wirteTagListSearchData:[HexHelper stingToHexadecimal:hexStr1]];

}

-(void)restartRFIDSearch{

//    self.isPopSearch = NO;
//
//    [self.RFIDDataArr removeAllObjects];
//    [self.searchDataArr removeAllObjects];
//    [self changeHeaderCountNum];
//    [self.tableView reloadData];
}

#pragma mark -- TagSearchPopViewDelegate
-(void)tagSearchPopViewCancelAction{
    [self.view endEditing:YES];
    self.searchPopView.hidden = YES;
}
-(void)tagSearchPopViewDelegateWithIndex:(NSIndexPath *)indexPath{
//    if (self.searchPopView.UIDTextField.text.length <= 0) {
//        return;
//    }
    [self.view endEditing:YES];
    [self.RFIDDataArr addObject:self.searchDataArr[indexPath.row]];
    [self.RFIDMoreArr addObject:self.searchMoreArr[indexPath.row]];
    [self.searchDataArr removeObjectAtIndex:indexPath.row];
    [self.searchMoreArr removeObjectAtIndex:indexPath.row];
    [self.tableView reloadData];
    self.searchPopView.hidden = YES;
}
-(void)tagSearchPopViewApplyWithIndex:(NSIndexPath *)indexPath{

    if (self.searchPopView.UIDTextField.text.length <= 0) {
        return;
    }

    [self.view endEditing:YES];

    if (self.isSweepYard && self.isCanSweepYard) {

    }else{
        self.isPopSearch = YES;
    }

    [self.wailCardSearchArr removeAllObjects];
    [self.wailCardMoreArr removeAllObjects];

    NSString *hexStr2 = [NSString stringWithFormat:@">x m 4\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr2]];

    NSString *hexStr = [NSString stringWithFormat:@">x l 901 %@\r\n",self.searchPopView.UIDTextField.text];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

    NSString *hexStr1 = [NSString stringWithFormat:@">f\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr1]];

    self.searchPopView.hidden = YES;
}

#pragma mark -- SingleTagSearchViewDelegate
-(void)singleTagSearchViewCancelAction{
    [self.view endEditing:YES];
    self.singlePopView.hidden = YES;
}
-(void)singleTagSearchViewApplyWithStr:(NSString *)textStr{

    if (self.singlePopView.UIDTextField.text.length <= 0) {
        return;
    }

    [self.view endEditing:YES];

    self.isPopSearch = NO;

    [self.RFIDDataArr removeAllObjects];
    [self.RFIDMoreArr removeAllObjects];
    [self.searchDataArr removeAllObjects];
    [self.searchMoreArr removeAllObjects];
    [self changeHeaderCountNum];
    [self.tableView reloadData];

    NSString *hexStr2 = [NSString stringWithFormat:@">x m 2\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr2]];

    NSString *hexStr = [NSString stringWithFormat:@">x l 001 %@\r\n",self.singlePopView.UIDTextField.text];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

    NSString *hexStr1 = [NSString stringWithFormat:@">f\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr1]];

    self.singlePopView.hidden = YES;
}

@end
