//
//  ViewController.m
//  HandheldBluetooth
//
//  Created by 伟 on 2018/10/19.
//  Copyright © 2018年 ZW. All rights reserved.
//

#import "ViewController.h"
#import "HandheldListViewController.h"
#import "SearchListHoldView.h"
#import "LeftMainView.h"
#import "HandheldSetViewController.h"
#import "TagListViewController.h"
#import "WriteCodeViewController.h"
#import "MemoryAccessViewController.h"

@interface ViewController ()<LeftMainViewDelegate>
{
    HandheldListViewController *listVC;
    HandheldSetViewController *setVC;
    TagListViewController *tagVC;
    WriteCodeViewController *writeVC;
    MemoryAccessViewController *memoryVC;
}

@property (nonatomic, strong) UIView *navigationBarView;

@property (nonatomic, strong) UIButton *leftButton;

@property (nonatomic, strong) UIButton *rightButton;

@property (nonatomic, strong) UILabel *titleLable;

@property (nonatomic, strong) UIButton *startButton;

@property (nonatomic, strong) UIButton *stopButton;

@property (nonatomic, strong) SearchListHoldView *holdingView;

@property (nonatomic, strong) LeftMainView *leftView;

@property (nonatomic, assign) NSInteger selectMainNum;

@end

@implementation ViewController

-(SearchListHoldView *)holdingView{
    if (!_holdingView) {
        _holdingView = [[[NSBundle mainBundle]loadNibNamed:@"SearchListHoldView" owner:self options:nil] lastObject];
        _holdingView.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.3f];
        [_holdingView.stopBtn addTarget:self action:@selector(stopAction) forControlEvents:UIControlEventTouchUpInside];
        _holdingView.frame = CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight);
        UIWindow *keyWin = [UIApplication sharedApplication].keyWindow;
        [keyWin addSubview:_holdingView];

        UITapGestureRecognizer *cancelTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(cancelHoldIng)];
        [_holdingView addGestureRecognizer:cancelTap];

        _holdingView.hidden = YES;
    }
    return _holdingView;
}
-(void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;
    self.navigationController.navigationBar.hidden = YES;
}
- (void)viewDidLoad {
    [super viewDidLoad];

    [self creatUI];
}

-(void)creatUI{
    self.view.backgroundColor = [UIColor whiteColor];

    self.navigationBarView = [[UIView alloc] init];

    self.navigationBarView.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.1f];
    [self.view addSubview:self.navigationBarView];
    [self.navigationBarView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.offset(0);
        make.right.offset(0);
        make.top.offset(0);
        if (KISIphoneX) {
            make.height.offset(64 + IPHONEX_TOP_HEIGHT);
        }else{
            make.height.offset(64);
        }
    }];

    UIView *topView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, KMainScreenWidth, 20)];
    if (KISIphoneX) {
        topView.frame = CGRectMake(0, 0, KMainScreenWidth, 20 + IPHONEX_TOP_HEIGHT);
    }
    topView.backgroundColor = [UIColor blackColor];
    [self.navigationBarView addSubview:topView];

    UIImageView *leftImg = [[UIImageView alloc]initWithFrame:CGRectMake(0, 20 + (44-16)/2.0f, 16, 16)];
    if (KISIphoneX) {
        leftImg.frame = CGRectMake(0, 20 + (44-16)/2.0f + IPHONEX_TOP_HEIGHT, 16, 16);
    }
    leftImg.image = [UIImage imageNamed:@"ic_drawer"];
    [self.navigationBarView addSubview:leftImg];

    //返回按钮
    self.leftButton = [UIButton buttonWithType:UIButtonTypeCustom];
    self.leftButton.backgroundColor = [UIColor clearColor];
    [self.leftButton setBackgroundImage:[UIImage imageNamed:@"a100"] forState:UIControlStateNormal];
    [self.leftButton addTarget:self action:@selector(leftButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    if (KISIphoneX) {
        [self.leftButton setEnlargeEdgeWithTop:30 right:25 bottom:10 left:15];
    }else{
        [self.leftButton setEnlargeEdgeWithTop:20 right:15 bottom:10 left:15];
    }
    [self.navigationBarView addSubview:self.leftButton];

    if (KISIphoneX) {

        [self.leftButton mas_makeConstraints:^(MASConstraintMaker *make) {

            make.left.offset(16);
            make.width.offset(34);
            make.height.offset(34);
            make.top.offset(20 + 5 + IPHONEX_TOP_HEIGHT);
        }];

    }else{

        [self.leftButton mas_makeConstraints:^(MASConstraintMaker *make) {

            make.left.offset(16);
            make.width.offset(34);
            make.height.offset(34);
            make.top.offset(20 + 5);
        }];
    }

    self.titleLable = [[UILabel alloc] init];
    self.titleLable.textColor = TextBlackColor;
    self.titleLable.textAlignment = NSTextAlignmentLeft;
    self.titleLable.font = [UIFont systemFontOfSize:18];
    self.titleLable.text = Localized(@"RFID手持拍列表BT4.0");
    [self.navigationBarView addSubview:self.titleLable];
    if (KISIphoneX) {
        [self.titleLable mas_makeConstraints:^(MASConstraintMaker *make) {

            make.top.offset(20 + 12 + IPHONEX_TOP_HEIGHT);
            make.width.offset(250);
            make.height.offset(20);
            make.left.offset(55);
        }];
    }else{
        [self.titleLable mas_makeConstraints:^(MASConstraintMaker *make) {

            make.top.offset(20 + 12);
            make.width.offset(250);
            make.height.offset(20);
            make.left.offset(55);
        }];
    }

    __weak typeof(self) weakSelf = self;

    self.rightButton = [UIButton buttonWithType:UIButtonTypeCustom];
    self.rightButton.backgroundColor = [UIColor clearColor];
    //    [self.rightButton setTitleColor:KHEXCOLOR(@"202532", 1) forState:UIControlStateNormal];
    [self.rightButton setBackgroundImage:[UIImage imageNamed:@"ic_action_bluetooth_searching_white"] forState:UIControlStateNormal];
    [self.rightButton addTarget:self action:@selector(rightButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    if (KISIphoneX) {
        [self.rightButton setEnlargeEdgeWithTop:15 right:10 bottom:15 left:10];
    }else{
        [self.rightButton setEnlargeEdgeWithTop:10 right:10 bottom:10 left:10];
    }
    [self.navigationBarView addSubview:self.rightButton];
    [self.rightButton mas_makeConstraints:^(MASConstraintMaker *make) {

        make.right.offset(-15);
        make.centerY.equalTo(self.titleLable.mas_centerY).offset(0);
        make.width.offset(32);
        make.height.offset(32);
    }];

    self.stopButton = [UIButton buttonWithType:UIButtonTypeCustom];
    self.stopButton.backgroundColor = [UIColor clearColor];
    //    [self.rightButton setTitleColor:KHEXCOLOR(@"202532", 1) forState:UIControlStateNormal];
    [self.stopButton setBackgroundImage:[UIImage imageNamed:@"ic_action_stop_white"] forState:UIControlStateNormal];
    [self.stopButton addTarget:self action:@selector(stopButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    if (KISIphoneX) {
        [self.stopButton setEnlargeEdgeWithTop:15 right:10 bottom:15 left:10];
    }else{
        [self.stopButton setEnlargeEdgeWithTop:10 right:10 bottom:10 left:10];
    }
    [self.navigationBarView addSubview:self.stopButton];
    [self.stopButton mas_makeConstraints:^(MASConstraintMaker *make) {

        make.right.offset(-15-32-30);
        make.centerY.equalTo(self.titleLable.mas_centerY).offset(0);
        make.width.offset(32);
        make.height.offset(32);
    }];

    self.stopButton.hidden = YES;

    self.startButton = [UIButton buttonWithType:UIButtonTypeCustom];
    self.startButton.backgroundColor = [UIColor clearColor];
    //    [self.rightButton setTitleColor:KHEXCOLOR(@"202532", 1) forState:UIControlStateNormal];
    [self.startButton setBackgroundImage:[UIImage imageNamed:@"ic_action_play_white"] forState:UIControlStateNormal];
    [self.startButton addTarget:self action:@selector(startButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    if (KISIphoneX) {
        [self.startButton setEnlargeEdgeWithTop:15 right:10 bottom:15 left:10];
    }else{
        [self.startButton setEnlargeEdgeWithTop:10 right:10 bottom:10 left:10];
    }
    [self.navigationBarView addSubview:self.startButton];
    [self.startButton mas_makeConstraints:^(MASConstraintMaker *make) {

        make.right.offset(-15-32*2-30*2);
        make.centerY.equalTo(self.titleLable.mas_centerY).offset(0);
        make.width.offset(32);
        make.height.offset(32);
    }];

    self.startButton.hidden = YES;


    listVC = [HandheldListViewController new];
    listVC.view.frame = CGRectMake(0, 64, KMainScreenWidth, KMainScreenHeight - 64);
    if (KISIphoneX) {
        listVC.view.frame = CGRectMake(0, 64+IPHONEX_TOP_HEIGHT, KMainScreenWidth, KMainScreenHeight - 64 - IPHONEX_TOP_HEIGHT);
    }
    [self addChildViewController:listVC];
    [self.view addSubview:listVC.view];

    setVC = [HandheldSetViewController new];
    setVC.view.frame = CGRectMake(0, 64, KMainScreenWidth, KMainScreenHeight - 64);
    if (KISIphoneX) {
        setVC.view.frame = CGRectMake(0, 64+IPHONEX_TOP_HEIGHT, KMainScreenWidth, KMainScreenHeight - 64 - IPHONEX_TOP_HEIGHT);
    }
    [self addChildViewController:setVC];
    [self.view addSubview:setVC.view];

    tagVC = [TagListViewController new];
    tagVC.view.frame = CGRectMake(0, 64, KMainScreenWidth, KMainScreenHeight - 64);
    if (KISIphoneX) {
        tagVC.view.frame = CGRectMake(0, 64+IPHONEX_TOP_HEIGHT, KMainScreenWidth, KMainScreenHeight - 64 - IPHONEX_TOP_HEIGHT);
    }
    [self addChildViewController:tagVC];
    [self.view addSubview:tagVC.view];

    writeVC = [WriteCodeViewController new];
    writeVC.view.frame = CGRectMake(0, 64, KMainScreenWidth, KMainScreenHeight - 64);
    if (KISIphoneX) {
        writeVC.view.frame = CGRectMake(0, 64+IPHONEX_TOP_HEIGHT, KMainScreenWidth, KMainScreenHeight - 64 - IPHONEX_TOP_HEIGHT);
    }
    [self addChildViewController:writeVC];
    [self.view addSubview:writeVC.view];

    memoryVC = [MemoryAccessViewController new];
    memoryVC.view.frame = CGRectMake(0, 64, KMainScreenWidth, KMainScreenHeight - 64);
    if (KISIphoneX) {
        memoryVC.view.frame = CGRectMake(0, 64+IPHONEX_TOP_HEIGHT, KMainScreenWidth, KMainScreenHeight - 64 - IPHONEX_TOP_HEIGHT);
    }
    [self addChildViewController:memoryVC];
    [self.view addSubview:memoryVC.view];

    [self.view bringSubviewToFront:listVC.view];

    if (KISIphoneX) {
        self.leftView = [[LeftMainView alloc]initWithFrame:CGRectMake(0, 64+IPHONEX_TOP_HEIGHT, KMainScreenWidth, KMainScreenHeight - 64 - IPHONEX_TOP_HEIGHT)];
    }else{
    self.leftView = [[LeftMainView alloc]initWithFrame:CGRectMake(0, 64, KMainScreenWidth, KMainScreenHeight - 64)];
    }
    self.leftView.delegate = self;
    [self.view addSubview:self.leftView];
    self.leftView.hidden = YES;

}

#pragma mark -- Event
-(void)leftButtonClick:(UIButton *)sender{
    [self.view endEditing:YES];
    sender.selected = !sender.selected;
    if (sender.selected) {
    [self.view bringSubviewToFront:self.leftView];
    self.leftView.hidden = NO;
    [self.leftView rightRemoveOut];
    }else{
        [self.leftView leftTakeBack];
    }
    [self changeTitleText];
}
-(void)rightButtonClick:(UIButton *)sender{

    if (self.selectMainNum == 0) {

    sender.selected = !sender.selected;

    [[NSNotificationCenter defaultCenter]postNotificationName:BlueToothSearch_Not object:[NSString stringWithFormat:@"%d",sender.selected]];

    if (sender.selected) {

        [self.leftView leftTakeBack];

        self.holdingView.hidden = NO;
    }else{
        self.holdingView.hidden = YES;
    }
    }else if (self.selectMainNum == 2){
        [[NSNotificationCenter defaultCenter] postNotificationName:TagListEmpty_Not object:nil];
    }else if (self.selectMainNum == 3){
        [[NSNotificationCenter defaultCenter] postNotificationName:WriteCodeWrite_Not object:nil];
    }
}
-(void)startButtonClick:(UIButton *)sender{

    [[NSNotificationCenter defaultCenter] postNotificationName:TagListStart_Not object:nil];

}
-(void)stopButtonClick:(UIButton *)sender{
    [[NSNotificationCenter defaultCenter] postNotificationName:TagListStop_Not object:nil];
}

//停止扫描
-(void)stopAction{

    [[NSNotificationCenter defaultCenter] postNotificationName:BlueToothSearch_Not object:@"0"];

    self.rightButton.selected = NO;
    self.holdingView.hidden = YES;
}

//取消Loading图
-(void)cancelHoldIng{
    self.rightButton.selected = NO;
    self.holdingView.hidden = YES;
}

-(void)changeTitleText{
    if (!self.leftView.isHidden) {

    self.titleLable.text = @"UHFA100app4.0";
    }else{
        NSArray *textArr = @[@"RFID手持拍列表BT4.0",@"RFID手持拍设置",@"标签列表搜索",@"写标",@"内存访问"];
        self.titleLable.text = Localized(textArr[self.selectMainNum]);
    }
}

#pragma mark -- LeftMainViewDelegate
-(void)selectRowWithNum:(NSInteger)selectNum{
    self.selectMainNum = selectNum;
    [self.leftView leftTakeBack];
}
-(void)animationHiddenAction{
    self.leftView.hidden = YES;
    self.leftButton.selected = NO;
    [self changeTitleText];

    self.rightButton.hidden = YES;
    self.startButton.hidden = YES;
    self.stopButton.hidden = YES;
    self.rightButton.enabled = NO;
    self.startButton.enabled = NO;
    self.stopButton.enabled = NO;
    if (self.selectMainNum == 0) {
        self.rightButton.hidden = NO;
        self.rightButton.enabled = YES;
        [self.rightButton setBackgroundImage:[UIImage imageNamed:@"ic_action_bluetooth_searching_white"] forState:UIControlStateNormal];
        [self.view bringSubviewToFront:listVC.view];
    }else if (self.selectMainNum == 1){
        self.rightButton.hidden = YES;
        self.rightButton.enabled = NO;

        [[NSNotificationCenter defaultCenter]postNotificationName:BlueToothSetInfoUpdate_Not object:nil];

        [self.view bringSubviewToFront:setVC.view];
    }else if (self.selectMainNum == 2){

//        [[NSNotificationCenter defaultCenter]postNotificationName:TagListInfo_Not object:nil];

        self.rightButton.hidden = NO;
        self.startButton.hidden = NO;
        self.stopButton.hidden = NO;
        self.rightButton.enabled = YES;
        self.startButton.enabled = YES;
        self.stopButton.enabled = YES;
        [self.rightButton setBackgroundImage:[UIImage imageNamed:@"ic_action_discard_white"] forState:UIControlStateNormal];
        [self.view bringSubviewToFront:tagVC.view];
    }else if (self.selectMainNum == 3){
        self.rightButton.hidden = NO;
        self.rightButton.enabled = YES;
        [self.rightButton setBackgroundImage:[UIImage imageNamed:@"ic_action_edit_white"] forState:UIControlStateNormal];

        [[NSNotificationCenter defaultCenter]postNotificationName:WriteCodeInfo_Not object:nil];

        [self.view bringSubviewToFront:writeVC.view];
    }else if (self.selectMainNum == 4){
        self.rightButton.hidden = YES;
        self.rightButton.enabled = NO;

        [self.view bringSubviewToFront:memoryVC.view];
    }
}

- (UIStatusBarStyle)preferredStatusBarStyle
{
    return UIStatusBarStyleLightContent;
}


@end
