//
//  WriteCodeViewController.m
//  HandheldBluetooth
//
//  Created by 伟 on 2018/10/29.
//  Copyright © 2018年 ZW. All rights reserved.
//

#import "WriteCodeViewController.h"
#import "SetSelectView.h"

NSString *const WriteCodeWrite_Not = @"WriteCodeWrite_Not";
NSString *const WriteCodeInfo_Not = @"WriteCodeInfo_Not";

@interface WriteCodeViewController ()<UITextFieldDelegate,SetSelectViewDelegate,BlueToothManagerWriteDelegate>
@property (weak, nonatomic) IBOutlet UIButton *writeBtn;
@property (weak, nonatomic) IBOutlet UITextField *powerTextField;
@property (weak, nonatomic) IBOutlet UITextField *bankTextField;
@property (weak, nonatomic) IBOutlet UITextField *datalengthTextField;
@property (weak, nonatomic) IBOutlet UIButton *AutoIncreaseBtn;
@property (weak, nonatomic) IBOutlet UITextField *offsetTextField;
@property (weak, nonatomic) IBOutlet UITextField *lengthTextField;
@property (weak, nonatomic) IBOutlet UITextField *writeTextField;
@property (weak, nonatomic) IBOutlet UITextField *resultTextField;
@property (weak, nonatomic) IBOutlet UITextField *categoryTextField;
@property (weak, nonatomic) IBOutlet UITextField *nameTextfield;
@property (weak, nonatomic) IBOutlet UITextField *countTextfield;
@property (weak, nonatomic) IBOutlet UILabel *lb1;
@property (weak, nonatomic) IBOutlet UILabel *lb2;
@property (weak, nonatomic) IBOutlet UILabel *lb3;
@property (weak, nonatomic) IBOutlet UILabel *lb4;
@property (weak, nonatomic) IBOutlet UILabel *lb5;
@property (weak, nonatomic) IBOutlet UILabel *lb6;
@property (weak, nonatomic) IBOutlet UILabel *lb7;
@property (weak, nonatomic) IBOutlet UILabel *lb8;
@property (weak, nonatomic) IBOutlet UILabel *lb9;

@property (nonatomic, strong) SetSelectView *selectView;

@property (nonatomic, assign) NSInteger selectNum;

@property (nonatomic, strong) NSArray *numArr;  //power数据

@property (nonatomic, strong) NSArray *bankArr;

@property (nonatomic, assign) NSInteger bankNum;

@end

@implementation WriteCodeViewController

-(NSArray *)bankArr{
    if (!_bankArr) {
        _bankArr = @[Localized(@"保留区"),Localized(@"EPC区"),Localized(@"TID区"),Localized(@"用户区")];
    }
    return _bankArr;
}
-(NSArray *)numArr{
    if (!_numArr) {
        _numArr = [NSArray array];

        NSMutableArray *numMutArr = [NSMutableArray array];
        for (NSInteger i = 30; i>2; i--) {
            [numMutArr addObject:[NSString stringWithFormat:@"%ld",i]];
        }
        _numArr = [numMutArr copy];
    }
    return _numArr;
}
-(SetSelectView *)selectView{
    if (!_selectView) {
        _selectView = [[SetSelectView alloc]initWithFrame:CGRectMake(0, 0, KMainScreenWidth, KMainScreenHeight)];
        _selectView.delegate = self;
        UIWindow *keyWin = [UIApplication sharedApplication].keyWindow;
        [keyWin addSubview:_selectView];
        _selectView.hidden = YES;
    }
    return _selectView;
}
-(void)dealloc{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}
- (void)viewDidLoad {
    [super viewDidLoad];

    [self creatUI];
}

-(void)creatUI{

    [self.AutoIncreaseBtn setEnlargeEdgeWithTop:10 right:10 bottom:10 left:10];
    self.writeBtn.layer.cornerRadius = 4;
    self.powerTextField.delegate = self;
    self.bankTextField.delegate = self;

    [BlueToothManager sharedManager].writeDelegate = self;

    self.bankNum = 1;

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(rightAction:) name:WriteCodeWrite_Not object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(infoAction:) name:WriteCodeInfo_Not object:nil];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(languageChange:) name:ZZAppLanguageDidChangeNotification object:nil];

    self.bankTextField.text = Localized(@"EPC区");
    self.categoryTextField.text = Localized(@"未注册");
    self.lb1.text = Localized(@"功率");
    self.lb2.text = Localized(@"存储区");
    self.lb3.text = Localized(@"起始地址");
    self.lb4.text = Localized(@"数据长度");
    self.lb5.text = Localized(@"自动计数");
    self.lb6.text = Localized(@"长度");
    self.lb7.text = Localized(@"类别");
    self.lb8.text = Localized(@"名称");
    self.lb9.text = Localized(@"数量");
    self.writeTextField.placeholder = Localized(@"写入值");
    self.resultTextField.placeholder = Localized(@"状态值");
    [self.writeBtn setTitle:Localized(@"写入") forState:UIControlStateNormal];
    
}
- (void)languageChange:(id)sender {
    if (self.isViewLoaded && !self.view.window) {
        self.view = nil;
    }
}
-(void)infoAction:(NSNotification *)not{

//    NSString *hexStr = [NSString stringWithFormat:@">y 5\r\n"];
    NSString *hexStr = [NSString stringWithFormat:@">y p\r\n"];

    [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];
}
-(void)rightAction:(NSNotification *)not{
    [self.view endEditing:YES];

    if (self.offsetTextField.text.length <= 0) {
        [MBProgressHUD showError:@"请输入起始字位置" toView:self.view];
        return;
    }
    if (self.lengthTextField.text.length <= 0) {
        [MBProgressHUD showError:@"请输入数据的字长度" toView:self.view];
        return;
    }
    if (self.writeTextField.text.length <= 0) {
        [MBProgressHUD showError:@"请填写数据" toView:self.view];
        return;
    }

    NSString *hexStr = [NSString stringWithFormat:@">w %.2ld %.2ld %.2ld %@\r\n",self.bankNum,[self.offsetTextField.text integerValue],[self.lengthTextField.text integerValue],self.writeTextField.text];

    [[BlueToothManager sharedManager] wirteLabelData:[HexHelper stingToHexadecimal:hexStr]];
}
- (IBAction)autoIncreaseAction:(UIButton *)sender {
    sender.selected = !sender.selected;
}
- (IBAction)writeAction:(UIButton *)sender {
    [self.view endEditing:YES];
    if (self.offsetTextField.text.length <= 0) {
        [MBProgressHUD showError:@"请输入起始字位置" toView:self.view];
        return;
    }
    if (self.lengthTextField.text.length <= 0) {
        [MBProgressHUD showError:@"请输入数据的字长度" toView:self.view];
        return;
    }
    if (self.writeTextField.text.length <= 0) {
        [MBProgressHUD showError:@"请填写数据" toView:self.view];
        return;
    }
    NSString *hexStr = [NSString stringWithFormat:@">w %.2ld %.2ld %.2ld %@\r\n",self.bankNum,[self.offsetTextField.text integerValue],[self.lengthTextField.text integerValue],self.writeTextField.text];

    [[BlueToothManager sharedManager] wirteLabelData:[HexHelper stingToHexadecimal:hexStr]];
}

#pragma mark -- UITextFieldDelegate
-(BOOL)textFieldShouldBeginEditing:(UITextField *)textField{
    if (textField == self.powerTextField) {

        [self.view endEditing:YES];
        self.selectNum = 0;
        self.selectView.dataArr = self.numArr;
        self.selectView.hidden = NO;

        return NO;
    }else if (textField == self.bankTextField){
        [self.view endEditing:YES];
        self.selectNum = 1;
        self.selectView.dataArr = self.bankArr;
        self.selectView.hidden = NO;
        return NO;
    }
    return YES;
}
- (IBAction)changeText:(UITextField *)sender {

    if (sender == self.writeTextField) {
        self.datalengthTextField.text = [NSString stringWithFormat:@"%ld",self.writeTextField.text.length];
    }

}

#pragma mark -- SetSelectViewDelegate
-(void)selectRowWithNum:(NSInteger)selectNum{
    if (self.selectNum == 0) {

        self.powerTextField.text = self.numArr[selectNum];

//        NSString *hexStr = [NSString stringWithFormat:@">x 5 %ld\r\n",30 - [self.numArr[selectNum] integerValue]];
        NSString *hexStr = [NSString stringWithFormat:@">x p %ld\r\n",30 - [self.numArr[selectNum] integerValue]];

        [[BlueToothManager sharedManager] wirteData:[HexHelper stingToHexadecimal:hexStr]];

    }else if (self.selectNum == 1) {

        self.bankNum = selectNum;

        self.bankTextField.text = self.bankArr[selectNum];
    }
    self.selectView.hidden = YES;
}
-(void)setViewCancelAction{
    self.selectView.hidden = YES;
}

#pragma mark -- BlueToothManagerWriteDelegate
-(void)getWritePowerWithStr:(NSString *)writePowerHexStr{

    self.powerTextField.text = [NSString stringWithFormat:@"%ld",30 - [writePowerHexStr integerValue]];
}

-(void)getWriteLabelWithReplyStr:(NSString *)replyHexStr{

    NSArray *dealArr = [replyHexStr componentsSeparatedByString:@"0D0A"];
    if (dealArr.count > 0) {

        NSString *hexstr = [dealArr firstObject];

        NSString * firstHexStr = [hexstr substringWithRange:NSMakeRange(2, hexstr.length - 2)];
        NSString * firstASCIIStr = [HexHelper toASCIIString:firstHexStr];
        if ([firstASCIIStr isEqualToString:@"E00000"]) {
            self.resultTextField.textColor = [UIColor blueColor];
            self.resultTextField.text = @"Memory access success";

            if (dealArr.count > 1) {
                NSString *hexstr1 = dealArr[1];

                NSString * twoHexStr = [hexstr1 substringWithRange:NSMakeRange(4, hexstr1.length - 4)];
                NSString * twoASCIIStr = [HexHelper toASCIIString:twoHexStr];
                self.writeTextField.text = twoASCIIStr;
            }

        }else{
            self.resultTextField.textColor = [UIColor redColor];
            self.resultTextField.text = [NSString stringWithFormat:@"Error：%@",firstASCIIStr];
        }

    }

}

@end
